//*******************************  pantype.pas *******************************
//*                                P A N A P I
//****************************************************************************
//                :    
//           : 
//****************************************************************************
//  maptype.pas      2008
// 30/01/13 -  .. -    sdk   2011

unit pantype;

interface

uses
  Windows, Types, Graphics;

//******* MAPERR.RH ***************  Panteleeva N.A.***** 10/07/06 ***
//*                                                                  *
//*              Copyright (c) PANORAMA Group 1991-2008              *
//*                      All Rights Reserved                         *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*                FOR WINDOWS 2000,XP & LINUX                       *
//*                                                                  *
//********************************************************************
//*                                                                  *
//*                            *
//*                                                                  *
//*******************************************************************/

// --------------------------------------------------------------
//      
// --------------------------------------------------------------


const
  MAPAPIVERSION =  $100200;

  IDS_MEM_ALLOC       = 60001 ;  //   
  IDS_MEMORY          = 60001 ;  //   
  IDS_DISK_ALLOC      = 60002 ;  //    
  IDS_READ            = 60003 ;  //   
  IDS_WRITE           = 60004 ;  //     
  IDS_STRUCT          = 60005 ;  //   
  IDS_OPEN            = 60006 ;  //   
  IDS_FILE_NOT_FOUND  = 60007 ;  //   
  IDS_PATH_NOT_FOUND  = 60008 ;  //   
  IDS_FILE_EXIST      = 60009 ;  //   
  IDS_CLOSE           = 60010 ;  //   
  IDS_CREATE          = 60011 ;  //   
  IDS_LOCK            = 60012 ;  //    

  IDS_FILE_MANY       = 60020 ;  //    
  IDS_OLD_VERSION     = 60030 ;  //   
  IDS_MODULE          = 60031 ;  //   MAPACCES.DLL
  IDS_PARM            = 60040 ;  //   
  IDS_ACCESS          = 60050 ;  //   
  IDS_COPYRIGHT       = 60060 ;  //   

  IDS_PROJECTTYPE     = 60100 ;  //   
  IDS_PROJECTPARM     = 60101 ;  //    

  IDS_OUTSIDE         = 60102 ;  // '   
  IDS_APPENDOBJECT    = 60103 ;  //    '
  IDS_RSCSTYLE        = 60104 ;  //   
  IDS_NOTFIND         = 60105 ;  // /  
  IDS_CANCEL          = 60106 ;  //   
  IDS_LOADLIBRARY     = 60107 ;  //   
  IDS_ENTRYLIBRARY    = 60108 ;  //    
  IDS_POINTFBsdObjectLIMIT      = 60109 ;  //    

  IDS_DATANOCROSS     = 60110 ;  //      10/10/01
  IDS_DATANOADJUST    = 60111 ;  //    
  IDS_DATARESULTLIMIT = 60112 ;  //   -  
  IDS_DATARESULTERROR = 60113 ;  //    

// -------------------------------------------------------------------
//       
//               60200   60299
// --------------------------------------------------------------------
  IDS_RSCAPPENDEXISTOBJECT = 60200 ;  //    '
  IDS_RSCAPPENDOBJECTERROR = 60201 ;  //    '
  IDS_RSCSTRUCTOBJECTERROR = 60202 ;  //   '
  IDS_RSCEXITSEGMENTERROR  = 60203 ;  //     
  IDS_RSCEXITSEMANTICERROR = 60204 ;  //     
  IDS_RSCSEMANTICCODEERROR = 60205 ;  //     
  IDS_RSCSEMANTICCODECHANGE =  60206 ; //    , -
                                       //   '   
                                       // 
  IDS_RSCSEMANTICCODEREPLY = 60207 ;  //   
  IDS_RSCSEMANTICTYPECHANGE = 60208 ;  //    -  
                                       //   '
  IDS_RSCSEMANTICREPLYCHANGE = 60209;  //    - 
                                      //    '
  IDS_RSCSEMANTICDEFCHANGE  = 60210;  //   

//     ;  // 10/07/06 
  IDS_FORMULESYNTAX         = 60220;  //  
  IDS_FORMULESEMERROR       = 60221;  //    
  IDS_FORMULEBRACKETERROR   = 60222;  //  
  IDS_FORMULESIZEERROR      = 60223;  //    
  IDS_FORMULECALCERROR      = 60224;  //   

  IDS_SENDERROR             = 60301;  //     
  IDS_RECVERROR             = 60302;  //     

{
/******************************************************************
********************    ***************************
*******************************************************************

    X X
  ^
  | (0,0) (  "Picture")
  +---------------------------------------------------> X
  |                                                 ^
  |        (  "Client")               |
  |   (0,0)                      X                 |
  |     ----------------------->                    |
  |     |               |                           |
  |     |        x..... x           |
  |     |        ....A. |                           |
  |     |        ...+.. |                           |
  |     |        ...... |                         
  |     ---------x------x                     ("Region")
  |     |          ^                                |
  |     |          |                                |
  |     |                      |
  |     V                  ("Draw")                 |
  |       Y                                        |
  |                                                 V
  +----------------------------------------------------> Y Y
  |
  |  0,0 (  "Map"  
  |        "")
  |
  V         .A   X,Y;   X,Y
    Y

******************************************************************/

}


const

 MaxNumberOBject = $7FFFFFFF; //       

 gtkMaxPath = 260;


//++++++++++++++++++++++++++++++++++++++++++++++++++++
//       
//++++++++++++++++++++++++++++++++++++++++++++++++++++
  MT_BADMAPTYPE   = 0;  //   
  MT_TOPOGRAPHIC  = 1;  // 
  MT_CK_42        = 1;  //   42 
  MT_GEOGRAPHIC   = 2;  // -
  MT_GLOBE        = 3;  //  ()
  MT_CITYPLAN     = 4;  //   
  MT_LARGESCALE   = 5;  //   
  MT_AERONAUTIC   = 6;  // 
  MT_SEANAUTIC    = 7;  //  
                        // (     WGS84)
  MT_AVIATION     = 8;  // 
  MT_BLANK        = 9;  // 
  MT_UTMNAD27     = 10; // UTM  North American Datum 1927
  MT_UTMWGS84     = 11; // UTM  WGS84
  MT_UTMTYPE      = 12; // UTM
  MT_CK_63        = 13; //   63 

  MT_CK_95        = 14; //   95   // 02/05/07
  // 24/12/09 (Transverse Mercator)
  MT_TOPOLOCAL    = 15; //     
  MT_MAPSPHERE    = 16;     // - /    // 15/04/10

  MT_WORLDMAP     = 17; //  

  MT_MCK_CK63     = 18; //      -63        // 28/02/11
  MT_MAPTYPELIMIT  = 18; //    



//    
  TR_ABSOLUTE    = 0; //  
  TR_AMOUNT      = 1; //  

//++++++++++++++++++++++++++++++++++++++++++++++++++++
//        

//     
  CSC_COUNTTOPO     = 7;        // 
  CSC_COUNTGEOG     = 5;        // -
  CSC_COUNTAERO     = 2;        // 
  CSC_COUNTCITYPLAN = 2;        //   

//    
  PR_NOADEQUACY = 0;   //    
  PR_ADEQUACY   = 1;   //   

//   "  "
  MP_GAUSSCONFORMAL              =  1; //  -
  MP_CONICALORTHOMORPHIC         =  2; //  
  MP_CYLINDRICALSPECIAL          =  3; //  
  MP_LAMBERT                     =  4; //   
  MP_STEREOGRAPHIC               =  5; // 
  MP_POSTEL                      =  6; // 
  MP_AZIMUTHALOBLIQUE            =  7; //   
  MP_MERCATORMAP                 =  8; //  
                                       //  
  MP_URMAEV                      =  9; //  (.)
  MP_POLYCONICAL                 = 10; //   
  MP_SIMPLEPOLYCONICAL           = 11; //   
  MP_PSEUDOCONICAL               = 12; //  
  MP_STEREOGRAPHICPOLAR          = 13; //  
  MP_CHEBISHEV                   = 14; //  
  MP_GNOMONIC                    = 15; // 
  MP_CYLINDRICALSPECIALBLANK     = 16; //  
                                       //   
  MP_UTM                         = 17; // UTM
  MP_KAVRAJSKY                   = 18; //  
                                       //   
  MP_MOLLWEIDE                   = 19; //  
                                       //   
  MP_CONICALEQUIDISTANT          = 20; // ()   
  MP_CONICALEQUALAREA            = 21; // ()   
  MP_CONICALDIRECTORTHOMORPHIC   = 22; // ()   
  MP_AZIMUTHALORTHOMORPHICPOLAR  = 23; //   
                                       // () 
  MP_LAMBERTAZIMUTHALEQUALAREA   = 24; // () 
                                       //   
  MP_URMAEVSINUSOIDAL            = 25; //  
                                       //    
                                       // (  )
  MP_AITOFF                      = 26; //  
                                       //  -
  MP_CYLINDRICALEQUALSPACED      = 27; //   
  MP_LAMBERTCYLINDRICALEQUALAREA = 28; //  
                                       //  
  MP_MODIFIEDPOLYCONICAL         = 29; //   
                                       //  ()
  MP_LAMBERTOBLIQUEAZIMUTHAL     = 30; //   
                                       //  
  MP_TRANSVERSECYLINDRICAL       = 31; //  -
                                       // 
  MP_GAUSSCONFORMAL_SYSTEM_63    = 32; //   63 

  MP_LATITUDELONGITUDE           = 33; // /                      // 15/04/10
  MP_MILLERCYLINDRICAL           = 34; //     ESRI:54003               // 22/12/10
  MP_WORLDMERCATOR               = 35; //     EPSG:3395 // 31/03/11
  MP_ASTPROJECTIONNUMBER         = 35; //   

 //   " "
   EK_UNDEFINED   = -1;       //  
   EK_KRASOVSKY42 =  1;       //  1942.
   EK_WGS_76      =  2;       //  1976.
   EK_HEFORD      =  3;       //  1909.
   EK_CLARKE_80   =  4;       //  1880.
   EK_CLARKE_66   =  5;       //  1866.
   EK_EVEREST_57  =  6;       //  1857.
   EK_BESSEL      =  7;       //  1841.
   EK_AIRY        =  8;       //  1830.
   EK_WGS_84      =  9;       //  1984.
   EK_SGS_85         = 10;    // -90.02
   EK_GRS_80         = 11;    // GRS80         (6378137.0, 298.257222101)
   EK_IERS_96        = 12;    // IERS 1996.   (6378136.49, 298.25645)
   EK_INTER_1924     = 13;    //  1924. (6378388.0, 297.00)
   EK_SOUTHAM_69     = 14;    // - 1969. (6378160.0, 298.25)
   EK_INDONESIAN_74  = 15;    //  1974. (6378160.0,  298.247)
   EK_HELMERT        = 16;    //  1906. (6378200.0,  298.3)
   EK_FISCHER_60M    = 17;    //  1960. Modified (6378155.0,  298.3)
   EK_FISCHER_68     = 18;    //  1968. (6378150.0,  298.3)
   EK_HOUGH          = 19;    //  1960. (6378270.0,  297.0)
   EK_EVEREST_30     = 20;    //  1830. (6377276.345,  300.8017)
   EK_AUSTRALIAN     = 21;    //   (6378160.0,  298.25)
   EK_CGCS2000       = 22;    // CGCS2000
   EK_AIRYM          = 23;    // Airy Modified
   EK_BESSELM        = 24;    // Bessel Modified
   EK_BESSELNAMIBIA  = 25;    // Bessel Namibia
   EK_BESSELGLM      = 26;    // Bessel Namibia (GLM)
   EK_CLARKE1880ARC  = 27;    // Clarke 1880 (Arc)
   EK_CLARKE1880SGA22 = 28;   // Clarke 1880 (SGA 1922)
   EK_EVEREST1830D67 = 29;    // Everest 1830 (1967 Definition)
   EK_EVEREST1830M   = 30;    // Everest 1830 Modified
   EK_EVEREST1830RSO69 = 31;  // Everest 1830 (RSO 1969)
   EK_EVEREST1830D75 = 32;    // Everest 1830 (1975 Definition)
   EK_NWL9D          = 33;    // NWL 9D
   EK_PLESSIS1817    = 34;    // Plessis 1817
   EK_STRUVE1860     = 35;    // Struve 1860
   EK_WAROFFICE      = 36;    // War Office
   EK_GEM10C         = 37;    // GEM 10C
   EK_OSU86F         = 38;    // OSU86F
   EK_OSU91A         = 39;    // OSU91A
   EK_GRS_67         = 40;    // GRS 1967
   EK_ATS_77         = 41;    // Average Terrestrial System 1977
   EK_IAG_75         = 42;    // IAG 1975
   EK_GRS_67M        = 43;    // GRS 1967 Modified
   EK_DANISH1876     = 44;    // Danish 1876
   EK_ELLIPSOIDCOUNT = 44;

   EK_USERELLIPSOID  = 1000;  //  () 

   EK_KRASOVSKY42_95 = 1001;  //  1942. -95  (don,t use)
   EK_EC90TEMP       = 1002;  // -90                     (don,t use)


 //   " "
  HS_BALTIC      =  1;       //   
  HS_LAMANSH     =  6;       //      
  HS_NORMALNULL  = 16;       //   C 
  HS_MARSEL      = 22;       //      
  HS_USAKANADA   = 24;       //     ,   
  HS_BALTIC77    = 25;       //   1977 .
  HS_OKHOTSK     = 26;       //       
  HS_PEACEOCEAN  = 27;       //    

 //   " "
  CS_ORTHOGONAL          = 1; //   42 
  CS_UNIVERSALMERCATOR   = 2; //   
  CS_NATIONALGRID        = 3; //    
  CS_AREAORTHOGONAL      = 4; //    
  CS_SYSTEM_63           = 5; //   63 
  CS_CONDITION           = 6; //     
  CS_GEOCOORDINATE       = 7; //  

 //   " "
  MU_KILOMETRE     =  5;    // 
  MU_METRE05       =  4;    // 0.5 
  MU_METRE         =  0;    // 
  MU_DECIMETRE     =  1;    // 
  MU_CENTIMETRE    =  2;    // 
  MU_MILLIMETRE    =  3;    // 
  MU_SECOND01      = 66;    // 0.1 
  MU_RADIAN        = 64;    // 
  MU_RADIAN8       = 67;    // 10e-8 
  MU_DEGREE        = 65;    // 
  MU_FOOT          = 16;    // 

 //   " "
  FK_TRAPEZE      = 1;      //    
  FK_TRAPEZECURVE = 2;      //    
  FK_RECTANGULAR  = 3;      // 
  FK_CIRCLE       = 4;      // 

  MIK_MAP     = 1;           // 
  MIK_PHOTO   = 2;           // 
  MIK_IMAGE   = 3;           // 
  MIK_GRAM    = 4;           // 

  MIT_MAPRUN        = 1;        //  
  MIT_FINAL         = 2;        //  
  MIT_MANUSCRIPT    = 3;        //  
  MIT_UPDATE        = 4;        //  
  MIT_SPECIAL       = 5;        //  
  MIT_CONSTANT      = 6;        //   
  MIT_FGM           = 7;        //  
  MIT_FGMMAPRUN     = 8;        //    
  MIT_FGMMANUSCRIPT = 9;        //    
  MIT_FGMFINAL      = 10;       //    
  MIT_FGMCONSTANT   = 11;       //     
  MIT_FGMSPECIAL    = 12;       //    

  PIK_SPACE     = 1;         // 
  PIK_AERO      = 2;         // 
  PIK_PHOTOGRAM = 3;         //  

  //      -
  SG_FGKSCALEMLN = 1;
  SG_FGKSCALE500 = 2;
  SG_FGKSCALE200 = 3;
  SG_FGKSCALE100 = 4;
  SG_FGKSCALE50  = 5;
  SG_FGKSCALE25  = 6;
  SG_FGKSCALE10  = 7;

  //    - 
  SO_FGEOSCALE10MLN = 1;
  SO_FGEOSCALE5MLN  = 2;
  SO_FGEOSCALE2MLN  = 3;
  SO_FGEOSCALEMLN   = 4;
  SO_FGEOSCALE500   = 5;

  //    
  SA_FARSCALE4MLN = 1;
  SA_FARSCALE2MLN = 2;

  //       
  SP_FCPSCALE25 = 1;
  SP_FCPSCALE10 = 2;

  //     
  TVT_COUNTMAPTYPE     = 10;             //  
  TVT_COUNTUNIT        = 12;             //  
  TVT_COUNTELL         = 10;             //  
  TVT_COUNTHEIGHT      =  9;             //  
  TVT_COUNTCOORD       =  8;             //  
  TVT_COUNTPROJ        = 17;             // 
  TVT_COUNTMAPINITKIND =  5;             //   
  TVT_COUNTMAPINITTYPE = 13;             //  
  TVT_COUNTPHOTO       =  4;             //  
  TVT_COUNTFRAME       =  5;             //  


 type
  TChar256 = array [byte] of char;

  PDATUMPARAM = ^TDATUMPARAM;
  TDATUMPARAM  = packed record
   DX : double;           //     
   DY : double;
   DZ : double;
   RX : double;            //    
   RY : double;
   RZ : double;
   M  : double;    //  
   Count : integer;        // 3  7  (14 -    -90.02  42\95)
   Reserve : integer;      //  0
  end;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                        // 26/02/10
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  PELLIPSOIDPARAM = ^TELLIPSOIDPARAM;
  TELLIPSOIDPARAM  = packed record
   SemiMajorAxis : double;          //    
   InverseFlattening : double;      //   
  end;

const
// -90.02  ->  WGS-84
  DX_SGS85_WGS84   =   -0.36;
  DY_SGS85_WGS84   =   +0.08;
  DZ_SGS85_WGS84   =   +0.18;
  RX_SGS85_WGS84   =    0.0;
  RY_SGS85_WGS84   =    0.0;
  RZ_SGS85_WGS84   =    0.0;
   M_SGS85_WGS84   =    0;

// -95  ->  -90.02  (Count = 14)
  DX_S95_SGS85     =   24.83;
  DY_S95_SGS85     = -130.97;
  DZ_S95_SGS85     =  -81.74;
  RX_S95_SGS85     =    0.0;
  RY_S95_SGS85     =    0.0;
  RZ_S95_SGS85     =   -0.13;
   M_S95_SGS85     =   -0.00000022;

// -42  ->  -90.02  (Count = 14)
  DX_S42_SGS85     =   23.93;
  DY_S42_SGS85     = -141.03;
  DZ_S42_SGS85     =  -79.98;
  RX_S42_SGS85     =    0.0;
  RY_S42_SGS85     =   -0.35;
  RZ_S42_SGS85     =   -0.79;
   M_S42_SGS85     =   -0.00000022;

// -95  ->  WGS-84 (Count = 7)
  DX_S95_WGS84     =   24.47;
  DY_S95_WGS84     = -130.89;
  DZ_S95_WGS84     =  -81.56;
  RX_S95_WGS84     =    0.0;
  RY_S95_WGS84     =    0.0;
  RZ_S95_WGS84     =   -0.13;
   M_S95_WGS84     =   -0.00000022;

// -42  -> WGS-84  (Count = 7)
  DX_S42_WGS84     =   23.57;
  DY_S42_WGS84     = -140.95;
  DZ_S42_WGS84     =  -79.8;
  RX_S42_WGS84     =    0.0;
  RY_S42_WGS84     =   -0.35;
  RZ_S42_WGS84     =   -0.79;
   M_S42_WGS84     =   -0.00000022;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        EPSG      // 11/02/11
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

type
//   
TAXISDIR  =(
   adUnknown,
   NORTH,  // 
   SOUTH,  // 
   WEST,   // 
   EAST    // 
);


// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        EPSG    // 11/02/11
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

TEPSGRECTSYS = packed record
  RectSysCode    : integer;    //        EPSG
  GeodSysCode    : integer;    //        EPSG
  UnitCode       : integer;    //       EPSG
  ProjectionCode : integer;    //      EPSG (. EPSGTRANSVERSEMERCATOR  ..)
                               //   EPSG -    
                               // ( COORD_OP_METHOD_CODE   Coordinate_Operation Method)
  XDirection     : TAXISDIR;   //    ( )
  YDirection     : TAXISDIR;   //   Y ( )
  RectSysName    : TChar256;  //        EPSG
end;

//   
TEPSGUNITTYPE = (
  LINEAR, //  (  - )
  ANGLE,  //   (  - )
  SCALE   //  
);

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//      EPSG                        // 11/02/11
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//   (  ,         )
TEPSGUNIT   = packed record
  UnitCode : integer;       //       EPSG
  UnitType : TEPSGUNITTYPE; // 
  Factor   : double;        //       
                            // (, , )
  Name     : array[0..127] of char; //   
end;
TEPSGMEASUNIT = TEPSGUNIT;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//        EPSG      // 11/02/11
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 TEPSGGEODSYS = packed record
  GeodSysCode   : integer;     //        EPSG
  UnitCode      : integer;     //       EPSG
  EllipsoidCode : integer;     //      EPSG
  DatumCode     : integer;     //      EPSG
                               //   EPSG -   
                               // ( COORD_OP_CODE   Coordinate_Operation,
                               //   ,   )
  GeodSysName   : TChar256;    //      EPSG
  EllipsoidName : TChar256;    //      EPSG
  DatumName     : TChar256;    //      EPSG
end;


const
//   
  KM_IDSHORT2  = $7FFF7FFF; //  
  KM_IDLONG2   = $7FFE7FFE; //  
  KM_IDFLOAT2  = $7FFD7FFD; //   
  KM_IDDOUBLE2 = $7FFC7FFC; //     
  KM_IDSHORT3  = $7FFB7FFB; //   
  KM_IDLONG3   = $7FFA7FFA; //   
  KM_IDFLOAT3  = $7FF97FF9; //    
  KM_IDDOUBLE3 = $7FF87FF8; //      
  KM_IDBAD     = $7FF87FF7; //  

  //    1 
  DEGREEINRAD  = 57.29577951308232;
  //    1 
  SECONDINRAD  = 206264.806247096;


//   (Intel)
    FILE_SXF = $00465853;   //  SXF 
    FILE_TXT = $4658532E;   //  SXF  (.SXF)
    FILE_DIR = $524944;     //  DIR 
    FILE_PCX = $10;         //  PCX (  )
    FILE_BMP = $4D42;       //  BMP
    FILE_TIFF= $4949;       //  TIFF
    FILE_JPEG= $D8FF;       //  JPEG
    FILE_MAP = $00505350;   //    MAP
    FILE_MAPSIT = $00544953;//    SIT
    FILE_RST = $00545352;   //  RST
    FILE_RSW = $00575352;   //  RSW
    FILE_MTR = $0052544D;   //  MTR
    FILE_MTW = $0057544D;   //  MTW
    FILE_MTL = $004C544D;   //  MTL
    FILE_SIT = $5449532E;   //  SXF(.SIT) 
    FILE_DXF = $00465844;   //  DXF
    FILE_MIF = $0046494D;   //  MAPINFO
    FILE_S57 = $00003000;   //  S57()
    FILE_DGN = $004E4744;   //  Macrostation(DGN)
    FILE_MPT = $0054504D;   //  MPT()
    FILE_RSC = $00435352;   //  RSC
    FILE_MTQ = $0051544D;   //  MTQ
    FILE_PLN = $004E4C50;   //  PLN (Talka)
    FILE_SHP = $00504853;   //  SHP (ArcView)
    FILE_TXFMAP  = $4658532E; //  SXF  (TXF   .SXF - MAP)
    FILE_MRSID   = $6469736D;   //  MrSid (SID,JPEG2000,NITF)  // 26/09/08
    FILE_RSWTIFF = $54575352;   //(RSWT)RSW+TIFF  // 24/05/11
    FILE_MTD  = $0044544D;   //  MTD  28/11/07
    FILE_TXFSIT = $5449532E; //  SXF  (TXF   .SIT - SIT)
    FILE_PLS  = $00534C50;   //  PLS ( )          // 05/07/04
    FILE_TEXT = $00545854;   //  TXT( )    // 23/11/04
    FILE_GPS  = $47504724;   //  GPS/NMEA ($GPG)               // 07/12/04
    FILE_GRD  = $00445247;   //  GRD (  FOTOMOD) // 10/12/04
    FILE_DBF  = $00464244;   //  DBF ( )             // 16/12/04
    FILE_TIN  = $004E4954;   //  TIN                           // 31/03/05
    FILE_XLS  = $0000CFD0;   //  EXCEL                         // 22/07/09
    FILE_WMS  = $00534D57;   // URL    WMS-  // 16/07/11
    FILE_IMG  = $00494D47;   //  IMG                           // 15/09/12
    FILE_PNG  = $00504E47;   //  PNG                           // 15/09/12
    FILE_GIF  = $00474946;   //  GIF                           // 15/09/12
    FILE_MAP_TURN = $50535000; //   
    FILE_MTW_TURN = $4D545700; //  MTW
    FILE_SXF_TURN = $53584600; //  SXF     //03/11/03
    FILE_DIR_TURN = $44495200; //  DIR    //05/12/03
    FILE_RSW_TURN = $52535700; //  RSW  // 20/01/04
    FILE_RSC_TURN = $52534300; //  RSC
    FILE_SIT_TURN = $2E534954; //  SXF(.SIT)  // 30/06/08
    FILE_MTR_TURN = $4D545200; //  MTR
    FILE_MTQ_TURN = $4D545100; //  MTQ
    FILE_RST_TURN = $52535400; //  RST

  //    

    LABEL_HDR      = $00524448;  // HDR0
    LABEL_DAT      = $00544144;  // DAT0
    LABEL_SEM      = $004D4553;  // SEM0
    LABEL_DRW      = $00575244;  // DRW0
    LABEL_VEC      = $00434556;  // VEC0
    LABEL_HDR_TURN = $48445200;  // 0RDH
    LABEL_DAT_TURN = $44415400;  // 0TAD
    LABEL_SEM_TURN = $53454D00;  // 0MES
    LABEL_DRW_TURN = $44525700;  // 0WRD
    LABEL_VEC_TURN = $56454300;  // 0CEV

   //      WMS
    MAPWMS  = 'WMS#';
    WMSSIZE = 4;

//      WMTS         // 07/02/12
    MAPWMTS  = 'WMTS#';
    WMTSSIZE  = 5;

//      
    GENERIC_OVERLAP =$AA;

//       s
  OL_LINE      = 0;         // 
  OL_SQUARE    = 1;         // 
  OL_MARK      = 2;         // 
  OL_TEXT      = 3;         // 
  OL_VECTOR    = 4;         // 
  OL_PATTERN   = 5;         // 
  MAXLOCALS    = 5;
type
  TLOCAL  = (L_LINE, L_SQUARE, L_MARK, L_TEXT, L_VECTOR, L_PATTERN);
  TLOCALS = set of TLOCAL;
const
  LocalsAll = [L_LINE, L_SQUARE, L_MARK , L_TEXT, L_VECTOR, L_PATTERN];

type
  //   
  TActionType = (AT_OPENFILE, AT_CLOSEFILE);

  //  
  TFileType = (MT_MAP, MT_SIT, MT_RSW, MT_RST, MT_MTW, MT_MTL, MT_MTQ, MT_MTR);


  TSmallString = array[0..31] of char;             //  
  TFullString  = array[0..255] of char;            //  
  TPathString  = array[0.. MAX_PATH-1] of char;    // 
//+++++++++++++++++++++++++++++++++++++++++++++++++++

const
  cERRORHEIGHT:double = -111111.0;  //   

{ 01/06/2008   mapviewa
  //    TMapView
  acNoAction     = $0000;     //  
  acClose        = $0001;     //  
  acOpen         = $0002;     //  
  acBeforePaint  = $0003;     //   
  acAfterPaint   = $0004;     //   
  acAppendSite   = $0005;     //   
  acDeleteSite   = $0006;     //  
}
  //   

  cTUNDEFINED = -1;  //   
  cTSTRING    = 0;   //  
  cTNUMBER    = 1;   //  
  cTANYFILE   = 9;   //    
  cTBMPFILE   = 10;  //   BMP
  cTOLEFILE   = 11;  //  , OLE-
  cTREFER     = 12;  //     
                     // (  )
  cTMAPFILE   = 13;  //  - 
  cTTXTFILE   = 14;  //    (OEM)
  cTPCXFILE   = 15;  //   PCX
  cTCODE      = 16;  //     
                     //   
  cDATE       = 17;  //      ()
  cTANGLE     = 18;  //    
  cTTIME      = 19;  //      ()
  cTFONT      = 20;
  cTCOLOR     = 21;
  //        MapApi

  cPP_MAP     = 1;   //       
  cPP_PICTURE = 2;   //       
  cPP_PLANE   = 3;   //      
                     //    
  cPP_GEO     = 4;   //     
  cPP_GEOWGS84 = 8;    //     
                       //     WGS-84
//     // 09/06/10
type
 TCURRENTPOINTFORMAT  =  (
   cpfUnknown,
   PLANEPOINT       ,  //         ("DocProjection")
                         //   1942. -42  -95,
                         //     -95 
   MAPPOINT        ,  //     ()
   PICTUREPOINT    ,  //     

   GEORAD          ,  //  
   GEOGRAD         ,  //  
   GEOGRADMIN      ,  //  , , 

                         //   WGS84
   GEORADWGS84     ,  //  
   GEOGRADWGS84    ,  //  
   GEOGRADMINWGS84 ,  //  , , 

   PLANE42POINT    , //         -42

                         //   -90.02 (SGS-85)
   GEORADPZ90      , //  
   GEOGRADPZ90     , //  
   GEOGRADMINPZ90  , //  , , 

   PLANEWORKSYS    , //            ("WorkSystem")
   GEORADWORKSYS   , //     
   GEOGRADWORKSYS  , //     
   GEOGRADMINWORKSYS , //   ,    
   PLANE95POINT  //         -95          // 15/11/10
);

const

  //  SEMANTIC_FOR_OBJECT   //    

  NONE_SEMANTIC     = 0;   //  
  POSSIBLE_SEMANTIC = 1;   // 
  MUST_SEMANTIC     = 2;   // 
  IMAGE_SEMANTIC    = 3;   //    
  ALL_SEMANTIC      = 4;   //  



  //     // 08/06/2004
//  
  cVT_SCREEN        = 1;  //  ( DIB)
  cVT_SCREENCONTOUR = 2;  //  
//   
  cVT_PRINT           = 3; //   ( WIN API)
  cVT_PRINTGLASS      = 4; //    
  cVT_PRINTCONTOUR    = 5; //  ,   
//   
  cVT_PRINTRST        = 6; //   ( WIN API)
  cVT_PRINTGLASSRST   = 7; //    
  cVT_PRINTCONTOURRST = 8; //  ,   
//   ()         // 13/02/03
  cVT_PRINTRSTSQUARE  = 9; //  ( ,   ,
                           //             , )
  cVT_PRINTRSTLINE    =10; //  (, , ,
                           //               , )
  cVT_PRINTRSTTEXT    =11; //  (, )

   //   () .   
   //  (POSTSCRIPT, WMF, EMF)                       // 16/12/04
  cVT_PRINTEX         =15; //   ( WIN API)
  //      

  cML_ENGLISH = 1;  // 
  cML_RUSSIAN = 2;  // 

 // ,    
 //   ,,   ,

  cWO_FIRST  = 0;    //   
  cWO_LAST   = 2;    //   
  cWO_NEXT   = 4;    //    
  cWO_BACK   = 8;    //    
  cWO_CANCEL = 16;   //   
  cWO_INMAP  = 32;   //     ( HSELECT)
  cWO_VISUAL = 64;   //     
  WO_VISUALIGNORE = 128; //       

  MSG_BUILDMTR     = $0581;
  MSG_WM_OBJECT    = $0585;       //  
  MSG_WM_LIST      = $0586;       //  
  MSG_WM_INFOLIST  = $0584;       //   
  MSG_WM_ERRORCOORD= $0583;       //    
  MSG_WM_ERROR     = $0587;       //   
  MSG_WM_MAP       = $0588;       //   
  MSG_WM_PROGRESSBAR  = $0590;       //     (07/09/2004)

  CIA_PAINT        = $0001;       //      
  SIA_PAINT        = $0001;       //    
  SIA_PAINT2       = $0002;

  //    /  
  SC_OR  = 16;  //    
  SC_AND = 32;  //  

  SCREENLIMIT  = 32 ;    //     

type

{$IFDEF _M_X64 OR BUILD_DLL64}
  HMAP      = int64;
  HOBJ      = int64;
  HRSC      = int64;
  HSELECT   = int64;
  HMTR3D    = int64;
  HSITE     = int64;
  HCROSS    = int64;
  HPrinter  = int64;
  HPOINT    = int64; // (   CROSSPOINT)
  HDRAW     = int64; // (   TDrawEdit)
  HVECT     = int64; // (  TVectorImageEdit)       // 29/07/03
  HMAPREG   = int64; /
{$ELSE}
  HMAP      = integer;
  HOBJ      = integer;
  HRSC      = integer;
  HSELECT   = integer;
  HMTR3D    = integer;
  HSITE     = integer;
  HCROSS    = integer;
  HSCREEN   = integer; //     
  HGRAPH    = integer; //    (  TGraph)
  HPrinter  = integer;
  HMAPREG   = integer;
  HALS      = Cardinal;      //    
{$ENDIF}

  HCHOICEOBJECT = Cardinal;   //     
                              // (  TChoiceObject)
  HTFCR    = Cardinal;          //    TIFF
  HTRIANG  = Cardinal;

{$IFDEF LINUXAPI}
  HWND    = integer;
  COLORREF= integer; 
  HDC     = integer;      // 19/02/04
  HPALETTE= integer;      // 19/02/04
  HBitmap = integer;      // 19/02/04
{$IFDEF BCB}              // Kylix CBuilder // 10/03/04
(*$HPPEMIT  '#if !defined(XLIB4_INCLUDE)'*)
(*$HPPEMIT  'typedef GC XGC;'*)
(*$HPPEMIT  'typedef struct {'*)
(*$HPPEMIT  '    short x, y;'*)
(*$HPPEMIT  '} XPoint;'*)
(*$HPPEMIT  '#endif'*)
{$ENDIF}
  //    XWindow
  XCONTEXT=record
    xcDisplay:PDisplay;
    xcWindow :Window;
    xcContext:TGC;
    xcPoint:XPoint;     // 21/11/01
  end;
{$ENDIF}

  TMAPFRAME = packed record 
    X1:longint;
    Y1:longint;
    X2:longint;
    Y2:longint;
  end;

  PMAPDFRAME = ^TMAPDFRAME;
  TMAPDFRAME = packed record
    X1:double;
    Y1:double;
    X2:double;
    Y2:double;
  end;



  TSEMANTICTYPE = packed record     //  
    //           //   
    fCode:longint;                  //  
    fType:longint;                  //  
    fReply:longint;                 // :   
    fMist:longint;                  // :   
    fService:longint;               // :   
    fName:TSmallString;    //  
    fUnit:array [1..8] of char;     //  
    fMinimum:double;                //  
    fDefault:double;                //  
    fMaximum:double;                //  
  end;

  TRSCSEMANTICEX = packed record     //  
                                     //   
    Code    : longint;               //  
    TypeSem : longint;               //   . cTSTRING ...
    Reply   : longint;               // :  (1)  
    Enable  : longint;               // : (1),(2)
    Service : longint;               // : ,    (1)
    Reserv  : longint;               //  (   0)
    Name    : TSmallString; //  
    UnitSem : array [1..8] of char;  //  
    Minimum : double;                //  
    Default : double;                //  
    Maximum : double;                //  
    Size    : longint;               //     
    Decimal : longint;               //    
    Key     : array [1..16] of char; //    (      )
  end;

//07/09/2004
//          
  TDATAINFORMATION = packed record
       InputFileLength : Cardinal; //    
       Width           : integer;  //  
       Height          : integer;  //  
       BitPerPixel     : integer;  // -   
       Precision       : double;   //    (\)
       PaletteType     : integer;  // 
       BlockCount      : integer;  // -   
       RswFileLength   : double;   //    *.rsw
       CompressImage   : array [1..16] of char;//   //
  end;


  THeightArray=array [1..1] of double;
  PHeightArray=^THeightArray;

  TMTRBUILDPARM = packed record
    BeginX : double;         //  
    BeginY : double;         //  (- )
                             //    
    Width  : double;         //    
    Height : double;         //    
    ElemSizeMeters : double; //   -
                             //    
    ReliefType:integer;      //   (0 -  ,
                             //  1 -  + )
                             //  2 -  
    Filter   : integer;      //    MTRCREA.TXT
                             // 0 -  , 1 - 
    UserType : integer;      //   
  end;

 TBUILDMTW = packed record  //      
  StructSize : integer;    //    :
                           //  sizeof (BUILDMTW)
  Free       : integer;    //   

  BeginX     : double;     //   
  BeginY     : double;     // (- )   

  Width      : double;     //    
  Height     : double;     //    

  ElemSizeMeters : double; //    
                           //    

  ElemSizeBytes : integer; // P    
                           // (  : 1,2,4,8)

  UnitH         : integer; // E  
                           // (0 - , 1 - ,
                           //  2 - , 3 -  )

  ReliefType    : integer; //   (0 -  ,
                           //    1 -  + 
                           //    2 - ) 12/03/2008

  UserType      : integer; //  , 
                           //   

  Scale         : integer; //   
                           //   (  
                           //     
                           //     
                           //   )

  HeightSuper   : integer; //     
                           //     
                           //  (0 - ,
                           // 1 - 
                           // 2 -   12/03/2008

  FastBuilding  : integer; // !!! !!!    :
                           //    14/03/2008

  Method        : integer; //    : // 12/03/2008
                           //  1 -    16 
                           //  2 -    8 
                           //  3 -    16 ,
                           //       
                           //  8 -     
                           //     (     )
                           //  16 -     
                           //        ReliefType = 2

 Extremum       :integer;  //    
                           //     ( Method = 1,2,3) :
                           //  0 -    
                           //  1 -   

 Border         : HOBJ;    //    ,
                           //     
                           //  (    
                           // ,   
                           // BeginX, BeginY, Width, Height 
                           // ,    )

 LimitMatrixFrame : integer;
                           //    
                           //  Method = 1,2,3,8 ( 
                           //    BeginX,
                           // BeginY, Width, Height  ) :
                           //  0 -   
                           //  1 -   
                           //       
                           //  2 -   
                           //        
                           //         

  NotUse3DMetric : integer;
                           //  -    
                           //  :
                           //  0 -   
                           //  1 -    

  SurfaceSquare3DObject : integer;
                           //  -    
                           //      :
                           //  0 -   
                           //  1 -  
                           //   NotUse3DMetric  1,
                           //    

  AltitudeMarksNet : integer;
                           //      
                           //   (Method = 1,2,3) :
                           //  0 -       
                           //            ( 
                           //       - 3D-,     
                           //      16  ;   
                           //          ,  
                           //            .
                           //            
                           //              
                           //         .
                           //  1 -      ,
                           //        (  )   
                           //        3D- (    
                           //        ,    ,
                           //       ,    , 
                           //            );
                           //  2 -      ,
                           //            ,
                           //          
                           //         

  LimitMatrixByFramesOfSheets : integer;
                           //     
                           // ( Method = 1,2,3,8) :
                           //  0 -    ,
                           //         
                           //        
                           //  1 -   ,
                           //        
                           //          

  Reserve : array [0 .. 19] of char;  //   

 end;

  TMTRDESCRIBE = packed record      //   
    fName : TFullString; //  
    fMinHeightValue : double;       //     
    fMaxHeightValue : double;       //     
    fElementInPlane : double;       //      
    fFrameMeters : TMAPDFRAME;      //   ()
    fReliefType  : integer;         //   (0 -  ,
                                    //  1 -  + )
                                    //  2 -  
                                    // (  )
    fUserType : integer;            //   
    fView : integer;                //  
  end;

  TGEODEGREE = packed record   //    
    Degree:longint;     // 
    Minute:longint;     // 
    Second:single;      // 
  end;

  PTASKPARM = ^TTASKPARM;
  TTASKPARM = packed record     //   
    Language    : longint;      //    (1 -ENGLISH, 2 - RUSSIAN, ...)
    Resource    : longint;      //   
    HelpName    : PChar;        //    ".hlp"
    IniName     : PChar;        //    ".ini" 
    PathShell   : PChar;        //   (exe,dll,...)
    AppName     : PChar;        //  
    Handle      : HWND;         //   
  end;
//   TTASKPARM     ".hlp",
//         6700,
//       ""

type
  PTASKPARMEX =^TTASKPARMEX;
  TTASKPARMEX = packed record       //   
    Language    : longint;      //    (1 -ENGLISH, 2 - RUSSIAN, ...)
    Resource    : longint;      //   
    HelpName    : PChar;        //    ".hlp"
    IniName     : PChar;        //    ".ini" 
    PathShell   : PChar;        //   (exe,dll,...)
    AppName     : PChar;        //  
    Handle      : HWND;         //   
    DocHandle   : HWND;         //   
    StayOnTop   : longint;      //      StayOnTop // 26/10/2006
  end;


{$IFDEF LINUXAPI}
const
 R2_COPYPEN    = 3;
 R2_NOT        = 10;
 R2_XORPEN     = 6;
 R2_NOTXORPEN  = 9;
{$ENDIF}

type
 PPAINTPARM = ^TPAINTPARM;
 TPAINTPARM = packed record
    Image : integer;    //   
    Parm  : pointer;    //     .
                        //   Image  IMG_OBJECT (
                        //      )
    Mode  : integer;    //    
                        //   R2_COPYPEN   -  
                        //   R2_NOT       -    ( )
                        //   IM_SCALE, IM_DONTSCALE, ... -  
                        //    (  Image  IMG_OBJECT)
                        //  : Mode = R2_NOT | IM_SCALE
  end;

  PDoublePoint = ^TDoublePoint;
  TDOUBLEPOINT = packed record
    X:double;
    Y:double;
  end;

  PTPoint = ^TPoint;
  PPoints = ^TPoints;
  TPoints = array [0..65535] of TPOINT;
  PIntegers = ^TIntegers;
  TIntegers = array [1..1] of integer;

  TTEXTRECORD =  packed record
    Length : integer;      //  ,   Length
    Text   : TFullString;  // ,   0
                           //     WINDOWS
  end;
  
//-----------------------------------------------------------------
//    '
//-----------------------------------------------------------------
//      
//     
//-----------------------------------------------------------------


  TPLACEDATA = packed record
    Points : PPoints;         //    
    PolyCounts : PIntegers;   //    
    Count : integer;          //     TEXTRECORD
                              //    IMG_TEXT :
    PolyText : ^TTEXTRECORD;  //   
                              //  TEXTRECORD,
                              //    Count
  end;

  TMTR3DVIEW = packed record
    AreaCenterX:double;       //    X,Y
    AreaCenterY:double;       //   (   )
    ViewPointX:double;        //   X,Y,H
    ViewPointY:double;        //   (   )
    ViewPointH:double;        //
    ShowScale:integer;        //  
    Style:byte;               // C (0 - , 1 - )
    ShowGrid:byte;            //   (0 - , 1 - )
    GridStep:byte;            //     (0 -  )
    ModelHeight:byte;         //     (2 - 127)
  end;

  TCOORDINATES = packed record
    Coord:array [1..4] of double;
  end;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++    ,   ++++++++++++++++++
//++++++++                   ++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

  TAPPENDPLANELIST = packed record
   Length        : integer;                //    APPENDLIST
   Nomenclature  : TSmallString;  //  
   ListName      : TSmallString;  //   
   FileName      : TFullString; //       
                                           //       
                                           // HDR,DAT,SEM ...
   Reserv        : integer;                //   ,   0
                                           // 19.10.2001

   //     
   // (   (SITE)   0)
   XSouthWest : double;  // X -
   YSouthWest : double;  // Y -
   XNorthWest : double;  // X -
   YNorthWest : double;  // Y -
   XNorthEast : double;  // X -
   YNorthEast : double;  // Y -
   XSouthEast : double;  // X -
   YSouthEast : double;  // Y -
  end;


 TCREATEPLANE = packed record
   Length  : integer;               //    CREATEPLANE
   MapName : TSmallString; //  
   Scale   : integer;               //   
   List    : TAPPENDPLANELIST;      //   
  end;

 TCREATESITE = packed record
   Length  : integer;            //    CREATESITE
   MapName : TSmallString; //  
   MapType : integer;            //   
   MaterialProjection : integer; //  . 
   Scale : integer;              //   
   //  
   FirstMainParallel  : double;  //   
   SecondMainParallel : double;  //   
   AxisMeridian       : double;  //  
   MainPointParallel  : double;  //   
  end;

 TCREATESITEEX = packed record   // 26/06/2007
   Length  : integer;            //    CREATESITE
//   MapName : array [1..255] of char; //     ANSI (UNICODE -   "Un")
   MapName : TFullString;        //     ANSI (UNICODE -   "Un") 13/08/2007
   MapType : integer;            //   
//   EllipsoideKind : integer;    //   (1 - , 9 - WGS84,...) 22/02/2009
   MaterialProjection : integer; //  . 
   EllipsoideKind : integer;     //   (1 - , 9 - WGS84,...) //22/02/2009
   Scale : integer;              //   
   Reserve : integer;            //  (  0)
   //  
   FirstMainParallel : double;   //   
   SecondMainParallel : double;  //   
   AxisMeridian : double;         //  
   MainPointParallel : double;    //   
   PoleLatitude : double;         //   
   PoleLongitude : double;        //   
  end;
  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  TMAPADJACENTSECTION = packed record     //   
    number:integer;                //  
    first:integer;                 //   
    last:integer;                  //   
  end;

//  TMAPADJACENTLIST = packed record
//    ListName:array [0..24] of char;     //  
//    Key:integer;                        //  
//    Number:integer;                     //  
//    First:integer;                      //   
//    Last:integer;                       //   
//  end;
//  TARRMAPADJACENTLIST = array [1..1] of TMAPADJACENTLIST;

  PMAPADJACENTLISTEX = ^TMAPADJACENTLISTEX;
  TMAPADJACENTLISTEX = packed record
    ListName  : TSmallString;            //  
    List      : integer;                 //    
    ObjectKey : integer;                 //  
    ObjectNum : integer;                 //     
    Excode    : integer;                 //   
    First     : integer;                 //   
    Last      : integer;                 //   
  end;
  PTMAPADJACENTLISTEX = ^TMAPADJACENTLISTEX;

//      
type
 TRSCOBJECT  = packed record
   Length  : integer  ; //  
   Code    : integer  ; //  
   Local   : integer  ; //    (OBJECT_LOCAL)
   Segment : integer  ; // 0  (   255)
   Scale   : integer  ; // 1 -   
                        // 0 -    
   Direct  : integer  ; //     (OBJECT_DIRECT)
   Bot     : integer  ; //    ( )
   Top     : integer  ; //    ( )
   Name    : TSmallString; //  (   30)
 end;

 TRSCOBJECTDESC  = packed record //( Code  Name   TRSCOBJECT)
   Code    : integer  ; //  
   Local   : integer  ; //    (OBJECT_LOCAL)
   Segment : integer  ; // 0  (   255)
   Scale   : integer  ; // 1 -   
                        // 0 -    
   Direct  : integer  ; //     (OBJECT_DIRECT)
   Bot     : integer  ; //    ( )
   Top     : integer  ; //    ( )
   Name    : TSmallString; //  (   30)
   Key     : TSmallString; //   -  (   30)
 end;


// 05/01/2005 -----------------------------------------------------
// C     
//     . (. MAPGDI.H)
//     -   
//   "" - TwoPoint = 1,  - 0;
//  ""  -  0;
// ----------------------------------------------------------------
 TIMAGESIZE = packed record
   Number : Cardinal;          //   
   Base   : Cardinal;          //   
   DeltaH : integer;           //    
   DeltaV : integer;           //    (
                               // ) 
   HorizontalSize : Cardinal;  //   
   VerticalSize   : Cardinal;  //   
   Parametrs : Cardinal;
        {  Horizontal     : 1 ;   //  
           Vertical       : 1 ;   //  
           TwoPoint       : 1 ;   //   2 
           AlignV         : 2 ;  //   
           AlignH         : 2 ;  //   
           Wide           : 2 ;  //  
           FontType       : 8 ;   //   (0-4)
           Rezerv         : 15 ;  // }
 end;//  IMAGESIZE;



//      
 type
  TRSCSEMANTIC = packed record
    fCode    : integer;               //    
    fType    : integer;               //   (SEMT_)
    fReply   : integer;               //  
    fService : integer;               // 1 -  
    fMetric  : array [0..7] of Char;  //   
    fName    : TSmallString; //  (   30)
 end;

  TPPLACE = (            //   
    PP_MAP,              //       
    PP_PICTURE,          //       
    PP_PLANE,            //      
                         //    
    PP_GEO               //     
                         //  
  );

  TMAPAPILANGUAGE = (     //      
    ML_NONE,              //  
    ML_ENGLISH,           // 
    ML_RUSSIAN            // 
  );
  TObjectStyle = (   //       TMapObj
    OS_NOVIEW,       //    
    OS_NORMAL,       //  OS_NOVIEW
    OS_SELECT        //    TObjectStyleSelect 
  );

  TObjectStyleSelect = ( //   ()   
    SEL_USERFUNC,    //    (  
                     //   Image, Mode, Parm
    SEL_COLOR,       //      
    SEL_LINE,        //  .  Image, Mode, Parm 
                     //     2  ( IMGLINE)
    SEL_BLINK1,      //       
                     // ColorImage,    Interval 
                     // ColorImageUp.     
                     //    (  ).
    SEL_BLINK2,      //       
                     // ColorImage,    Interval 
                     // ColorImageUp.    
                     //  ( IMGSQUARE),     
                     //     2  ( IMGLINE)
    SEL_OBJUP,       //      
    SEL_OBJUPMODE,   //       ,
                     //     ,   Mode
    SEL_BLINK3       //        
                     //    R2_COPYPEN,    Interval
                     //    R2_NOT

  );

   TSemanticStyle = ( //      
    SS_NODECODE,     //   
    SS_NORMALDECODE, //  
    SS_FULLDECODE    //      
  );

  TColorStyle = (    //    
    CS_GRAYSCALE,    //   
    CS_COLOR         //  
  );

  TSemanticCondition = (   //  /  
    SC_BAD,       //   
    SC_LESS,      // 
    SC_EQUAL,     // 
    SC_LESSEQ,    //   
    SC_MORE,      // 
    SC_NOTEQ,     //  
    SC_MOREEQ,    //   
    SC_ANY       //  
    );


const
    SC_CMOR  = 16; //      
    SC_CMAND = 32; //  

   // 26/04/11
   cSO_SEEKBYDISTANCE     = 0;  //   
   cSO_SEEKINSIDEANDCROSS = 1;  //   ,    
   cSO_SEEKINSIDEONLY     = 2;  //   ,   
   cSO_SEEKOUTSIDEONLY    = 4;  //   ,   


   //   
   cSTF_CONTOUR = 0;  //  
   cSTF_OBJECT  = 1;  //    

   //     
   cSELECTLIST_EXCLUSIVE = 0;  //     
   cSELECTLIST_UNION     = 1;  //     
   cSELECTLIST_CROSS     = 2;  //     

   //   "    25/04/02

   MEASURE_LENGTH      = 1;   //  ()
   MEASURE_SQUARE      = 2;   //  (.)
   MEASURE_PERIMETER   = 3;   //  ()
   MEASURE_HEIGHT      = 10;  //  ()


//   
  CC_ASCIIZ  = 0;   // C  (ASCIIZ),  
  CC_KOI8    = 125;   // C (KOI8),  
  CC_ANSI    = 126;   // C (ANSI, WINDOWS),  
  CC_UNICODE = 127;   // C  (UNICODE),  

//  

  SPLINETYPE_NONE   = 0;  //  
  SPLINETYPE_SMOOTH = 2;  //   ( )
  SPLINETYPE_POINTS = 4;  //   (  )

//  

  cOD_NONE      = 0;     // . :
                         // -  ;
                         // -   ,   
                         //      ( );
                         // -   ,  
                         //        ()

  cOD_ALONG     = 1;     //  ( ). :
                         // -  ;
                         // -   ,   
                         //    (  -    );
                         // -   ,   

  cOD_UNDEFINED = 1;     //  .    
                         //    ,    
                         //    (     "")

  cOD_RIGHT     = 2;     //    .   :
                         //     -   ;
                         //         -   


  cOD_LOWRIGHT  = 3;     //  .   .
                         //    :
                         // -     ;
                         // -     

      
  cOD_LEFT      = 4;     //    .   :
                         //     -   
                         //         -   

  cOD_CLOCKWISE = 5;     //         //23/01/12

  cOD_ANTICLOCKWISE = 6; //       

  cOD_LAST      = 6;     //    
                                      



type


TPOINTPOSITION  =      //    
(
  PS_UNKNOWN,
  PS_FIRST  ,          //     
  PS_SECOND ,          //     
  PS_BEHIND ,          //     
  PS_BEYOND ,          //     
  PS_BETWEEN,          //    ( )
  PS_LEFT   ,          // 
  PS_RIGHT             // 
);


  TConvertorTypeSource = (    //    
    TS_VIEW,
    TS_MAP,
    TS_DIR,
    TS_SXF,
    TS_TXT,
    TS_S57
  );

  TConvertorTypeDest = (    //    
    TD_VIEW,
    TD_MAP,
    TD_DIRSXFWIN,
    TD_DIRSXFDOS,
    TD_DIRTXTXY,
    TD_DIRTXTBL,
    TD_SXFWIN,
    TD_SXFDOS,
    TD_TXTXY,
    TD_TXTBL
  );

//   
const
  SEMT_TSTRING    = 0;     //  
  SEMT_TNUMBER    = 1;     //  
  SEMT_TBMPFILE   = 10;    //   BMP
  SEMT_TOLEFILE   = 11;    //  , OLE-
  SEMT_TREFER     = 12;    //     
                           // (  )
  SEMT_TMAPFILE   = 13;    //  - 
  SEMT_TTXTFILE   = 14;    //   
  SEMT_TPCXFILE   = 15;    //   PCX
  SEMT_TCODE      = 16;    //     
                           //   

//   
type
  TMETAFILEBUILDPARM = packed record
  CenterX    : integer;     //    
  CenterY    : integer;     // (   )
  Width      : integer;     //   ( )
  Height     : integer;     //   ( )
  Scale      : integer;     //  
  VisualType : integer;     //  
                            //  1 -  (BITMAP)  BMP
                            //  2 -  (BITMAP)  BMP
                            //  3 - 
                            //  4 -   (  )
                            //  5 -  
 end;

//    
type
  TMETAFILEBUILDPARMEX = packed record
  Frame      : TMAPDFRAME;  //      
  Scale      : integer;     //  
  VisualType : byte;        //  
                            //  1 -  (BITMAP)  BMP
                            //  2 -  (BITMAP)  BMP
                            //  3 - 
                            //  4 -   (  )
                            //  5 -  
  Border     : byte;        //   
  Intensity  : byte;        //   % (0-100)
  Black      : byte;        //  - (1 - , 0 - )
  DontClip   : byte;        // 0 -      1 -  
  Reserve    : array [0..6] of byte;  //  (  )
 end;

//******************************************************************
//                   *
//  (     mapgdi.h
//******************************************************************
//        (, ,  ...)      *
//                 (   )                   *
//******************************************************************

//     
const MKMINPIX = 260;  //  1000 * 25.4 / 96 = 264.583333


type
 TOBJECTFORM = packed record    //     '
  Window          : HWND;      //   
  Position        : TPoint;    //                //28/11/02
  LeftTopPosition : TPoint;    //             //28/11/02
  PlaceSystem     : integer;   //      :
                               // 1 -    
                               // 2 -     ()
                               // 3 -     
                               //       1942.
                               // 4 -      
                               // 5 -   ...
                               // 6 -  , ,  ...
                               // 7 -   (  WGS84)                    //28/01/05
                               // 8 -   (  WGS84)
                               // 9 -  , ,  (  WGS84)
  FormMode        : shortint;  //    
                               // 0 -     
                               // 1 -     
                               // 2 -     
                               // 3 -      
                               // 4 -      
                               // 5 -      
                               // 6 -      
                               // -1 - -6     
  MarkPointMode  : shortint;   //    
                               //   
                               //      
                               //      
                               // 0 -      
                               // 1 -     
                               //   
                               // 0 -   ,  
                               // 1 -   
  Map            : HMap;       //    
                               // (  TMapAccess)
 end;

  //       
  const
   dlMinCommon   =  0;  //    
   dlMinSemantic =  1;  //    
   dlMinMetric   =  2;  //    
   dlMinScale    =  3;  //     
   dlMinImage    =  4;  //     
   dlMinPrint    =  5;  //     
   dlMinGrafic   =  6;  //     
   dlMaxSemantic = -1;  //       
   dlMaxMetric   = -2;  //       
   dlMaxScale    = -3;  //        
   dlMaxImage    = -4;  //        
   dlMaxPrint    = -5;  //        
   dlMaxGrafic   = -6;  //        

//   
type
 TTypeSelectRect = (slNewRect, slChangeRect);
      // slNewRect    -  
      // slChangeRect -     Rect

type
 //        // 13/09/00
  TViewMapType = (
       VT_NONE,           // 0 -  
       //  
       VT_SCREEN,         // 1 -  ( DIB)
       VT_SCREENCONTOUR,  // 2 -  
       //   
       VT_PRINT,          // 3 -   ( WIN API)
       VT_PRINTGLASS,     // 4 -    
       VT_PRINTCONTOUR,   // 5 -  ,   
       //   
       VT_PRINTRST,       // 6 -   ( WIN API)
       VT_PRINTGLASSRST,  // 7 -    
       VT_PRINTCONTOURRST // 8 -  ,   
                 );

 //   
  TPrintMapType = (
       //   
       PT_PRINT,          //   ( WIN API)
       PT_PRINTGLASS,     //    
       PT_PRINTCONTOUR,   //  ,   
       //   
       PT_PRINTRST,       //   ( WIN API)
       PT_PRINTGLASSRST,  //    
       PT_PRINTCONTOURRST //  ,   
                 );
type
 //  
  TTYPECOORD  = (Metre,   //  
                 Degree,  //  
                 Radian); //  


type
 //   
  TRstViewType = 0..5;
  // = 0 -  
  // = 1 -  
  // = 2 - 
  // = 3 - 
  // = 4 - 
  // = 5 - 

 //  
  TRstContrast = -16..16;

 //  
  TRstBright = -16..16;

 //   
  TRstGamma = -32..32;

 //   
  PCOLORREF = ^COLORREF;

 //     
  TViewScaleRange = packed record
     TopScale    : integer;
     BottomScale : integer;
     end;

// 14/12/2006
//   OLE 
type
  TDocFileInfo = packed record              // 64 
    StructSize : longint;                   //   sizeof(DOCINFOMATION)
    PartCount  : longint;                   //   
    Reserv     : array [1 .. 14] of longint;
  end;
  PTDocFileInfo = ^TDocFileInfo;

//   OLE 
type
  TPartInfo = packed record                  // 128 
    StructSize    : longint;                 //   sizeof(DOCINFOMATION)
    PartRect      : TRect;                   //    (16)
    Name          : array [1 .. 52] of char; //   
    Color         : integer;                 //  
    IsColorActive : byte;                    //      0/1
    Reserve       : array[1 .. 3] of char;   // 
    DataType      : longint;                 //    
    View          : byte;                    //   OLE- (0/1)
    SizeMode      : array [1 .. 10] of char; //   OLE-   OLE-
    PlaceType     : byte;                    //    
    FirstPlace    : TDOUBLEPOINT;            //     
    SecondPlace   : TDOUBLEPOINT;            //     
  end;
  PTPartInfo = ^TPartInfo;

//    OLE 
type
  TBaseSchemeInfo = packed record
     StructSize    : longint;            //   sizeof(SCHEMEINFOMATION)
     CountScheme   : longint;            //     
     CurrentScheme : longint;            //     (  1)
     Reserv        : array[1 .. 13] of longint;
  end;
  PTBaseSchemeInfo = ^TBaseSchemeInfo;

//   OLE 
type
  TSchemeInfo = packed record
     StructSize   : longint;                 //   sizeof(SCHEMEINFOMATION)
     NumberScheme : longint;                 //      
     NameScheme   : array[1 .. 64]  of char; //     
     IndexView    : array[1 .. 128] of char; //     (0/1)
     Reserv       : array[1 .. 56]  of char; // 
  end;
  PTSchemeInfo = ^TSchemeInfo;

//   MapTop, MapLeft      // 06/02/2007
type
  TMAPPOS = packed record
    MapTop  : integer;
    MapLeft : integer;
  end;

const
  //    ,  200...,  
  MSG_AW_OPENDOC          = $655; //   
  MSG_AW_GETCURRENTDOC    = $673; //     
  MSG_MT_CHANGEDATA       = $65D; //  

// --------------------------------------------------------------
//      -
// --------------------------------------------------------------

type
  TMCUSERPARM = packed record //  
     Name         : array[0 .. 31]  of char; //  ( ANSI)
     Password     : array[0 .. 63]  of char; // 
   end;

  TMCMAPLISTITEM = packed record //   
     Level        : longint;     //     1  MaxLevel
     Flags        : longint;     //   0 -   
     TypeLevel    : longint;     //   MAPFILES,   0 - 
     Reserve      : longint;     //
     Name         : array[0 .. 255]  of char; //   ()
   end;

  TMCMAPLIST  = packed record  //   
     Ident        : longint;     //   0x7F7F7F7F
     Length       : longint;     //   
     Count        : longint;     //    
     MaxLevel     : longint;     //     ()
     Item         : TMCMAPLISTITEM; //      (  Count)
   end;


// ----------------------------------------------------------------
//   
// ----------------------------------------------------------------
 TBreakCall   = function(Parm : integer): integer of object;
 TBeforePaint = function(Parm : integer; DC :HDC; varRect : TRect): integer of object;
 TMaskCall    = function(Parm : integer): integer of object;  // 15/02/05

 type
 // HINSTANCE  = cardinal;
  HFORMULA   = cardinal;
  HImage     = cardinal;
  HMrt3d     = cardinal;
  HObjSet    = cardinal;
  HDraw      = Cardinal;
  TDRAWPOINT = Types.TPoint;
//        :
 const
   SEMNETRIB       = 32812;  //  - ( )
   SEMNETKNOTFIRST = 32813;  //  -   ( )
   SEMNETKNOTLAST  = 32814;  //  -   ( )
   SEMNETNUMBER    = 32815;  //  
   SEMNETTOOBJECT  = 32816;  //    
   SEMNETVDIRECT   = 32817;  //   ( )
   SEMNETVUNDIRECT = 32818;  //   ( )
   SEMNETCOSTRIB   = 32819;  //  
   SEMNETRANKRIB   = 32820;  //  
//        
// 5557   //   
// 5558   //  
// 5559   // 
// 5560   //  
// 5561   //   
// 5562   //   
type
 TDFRAME  = packed record
   X1,Y1,
   X2,Y2 : double;
 end;

//------------------------------------------------------------------
//      ( )
//------------------------------------------------------------------
type
 TMTLBUILDPARM = packed record  //   128 
  StructSize 	: cardinal; 	//    sizeof (MTRLAYERBUILDPARM)
  BeginX 	: double; 	//   
  BeginY	: double; 	// (- )   
  EndX	        : double; 	//   
  EndY	        : double; 	// ( -  )   
  ElemSizeMeters : double; 	//        
  layerCount 	: integer; 	//  
  layerForm 	: integer; 	//   -  
 		                //   :
 		                // 0 -  
 		                // 1 -  
  HeightSizeBytes : integer; 	//     
 		                //   :
 		                // 0 -  ;
 		                // 2 -  "short int"
 		                // 4 -  "long int"
  layerSizeBytes : integer; 	//     
 		                //   :
 		                // 1 -  "unsigned char"
 		                // 2 -  "unsigned short int"
 		                // 4 -  "unsigned long int"
  HeightMeasure  : integer; 	// E  
                                //   :
 		                // 0 - 
 		                // 1 - 
 		                // 2 - 
 		                // 3 - 
  layerMeasure 	: integer; 	// E   
 		                //  
 		                // -  ;  HeightMeasure
  UserType 	: integer; 	//  ; 
 		                //   
  Scale 	: integer; 	// 
  Reserve 	: array[0..51] of char; 	//   
end;


TBUILDMTL = packed record      //   160 
 StructSize 	: cardinal; 	//    sizeof (BUILDMTL)
 sFree 	        : integer; 	//   
 BeginX 	: double; 	//   
 BeginY	        : double; 	// (- )   
 EndX	        : double; 	//   
 EndY	        : double; 	// ( -  )   
 ElemSizeMeters : double; 	//        
 layerCount 	: integer; 	//  
 layerForm 	: integer; 	//   -  
 		                //   :
 		                // 0 -  
 		                // 1 -  
 HeightSizeBytes : integer; 	//     
 		                //   :
 		                // 0 -  ;
 		                // 2 -  "short int"
 		                // 4 -  "long int"
 layerSizeBytes	: integer; 	//     
 		                //   :
 		                // 1 -  "unsigned char"
 		                // 2 -  "unsigned short int"
 		                // 4 -  "unsigned long int"
 HeightMeasure 	: integer; 	// E  
                                //   :
 		                // 0 - 
 		                // 1 - 
 		                // 2 - 
 		                // 3 - 
 layerMeasure 	: integer; 	// E   
 		                //  
 		                // -  ;  HeightMeasure
 UserType 	: integer; 	//  ; 
 		                //   
 Scale 	        : integer; 	// 
 BlockSide 	: integer; 	//      
 		                //   	: 0 - 64
 		                // (  0;   64)
 codeCount 	: integer; 	//    10/06/08
 sFree2 	: integer;
 Reserve 	: array[0..67] of char; 	//   
End;




//------------------------------------------------------------------
//      (  1024 )
//------------------------------------------------------------------
TMTLDESCRIBE  = packed record
 Name : array[0..259] of char; 	//   
 MaterialFileName: array[0..259] of char;	//    
 LayerCount	: integer; 	// - 
 MaterialCount	: integer; 	// - 
 ElementInPlane	: double; 	//      
 FrameMeters	: TDFRAME; 	//     ()
 MinHeightValue	: double; 	//       ()
 MaxHeightValue	: double; 	//       ()
 BotLevelHeight	: double; 	//      () // 24/10/00
 UserType	: integer; 	//   
 View	        : integer; 	//  
 UserLabel	: integer; 	//  
 ReliefPresence	: integer; 	//    17/01/01
 MaxSummaryPower: double; 	//     () // 17/05/01
 Reserve : array[0..407] of char; 	// 
end;


 type
  PCrossPoint = ^TCrossPoint;
  TCrossPoint = packed record
    XY       : TDoublePoint; //   
    H        : double;       //     ( )
    Obj1     : HObj;
    Number1  : integer;      //     Info1   
    Subject1 : integer;      //  /  info1
    Obj2     : HObj;
    Number2  : integer;      //     Info2   
    Subject2 : integer;      //  /  info2
  end;

  TNumberPoint = packed record
    Point   : TDoublePoint;   //  
    Number  : integer;     //   ,    point
    Update  : integer;     //    
    Equal   : integer;      //     
    Reserve : integer;
  end;

 const
  cDELTANULL =  1e-3;


  //    
  cAREA_ALL            = 0; //  :   -  
                           //  :    
  cAREA_FRAME          = 1; //  :   -  RectMetr
                           //  :   ->  RectMetr
  cAREA_SELECT_FRAME   = 2; //  :   -  RectMetr
                           //  :    
  cAREA_CHANGE_FRAME   = 3; //  :   -  RectMetr
                           //  :   
  cAREA_MOVE_FRAME     = 4; //  :   -  RectMetr
                           //  :   
  cAREA_SELECT_OBJECT  = 5; //  :   -  RectMetr
                           //  :      
  cAREA_SELECT_CONTOUR = 6; //  :   -  RectMetr
                           //  :       
  cAREA_SELECT_TURN_FRAME = 10; //    

//-----------------------------------------------------------------
//       
// (      
//         RGB  CMYK)
//-----------------------------------------------------------------

Type
 HMessage = HWnd;

TSAVEASPICTRPARM_FOR_PRINT = packed record
 Length 	: integer;   	//   SAVEASPICTRPARM_FOR_PRINT
 Handle 	: HMessage; 	//    ( 
          		        //   )

 Map 	        : HMap;	        //  
 Regime	        : integer;	//    
          		        // (cAREA_ALL; cAREA_SELECT_FRAME; ... - . )

 PlaneFrame 	: TDFRAME; 	//     

 DPI 	        : double;   	//   (  )
 LPI            : double;    	//     ( Method = 0 ).
          		        //      Shape

 FactorVer	: double; 	//    
 FactorHor	: double; 	//    
 Rect	        : TRect;    	//      
                  		// (   RGB  )     	//24/04/08
 Scale	        : integer;   	//  ()

 BitCount	: integer;  	//      
          		        //  ColorModel == 0:             	// 20/04/08
          		        //  8;16;24;32    (RGB)
          		        //  ColorModel == 1:
          		        //  1;8    (CMYK) -   BMP  PCX
          		        //  32    (CMYK) -   TIF
 Intensity	: integer; 	//     (0-100)
 ColorModel	: integer; 	//   :
          		        //  0 - RGB (  )
          		        //  1 - CMYK BMP  CMYK PCX ( 8-
          		        //     1- ;  
          		        //    ;    
          		        //      "-C";"-M";"-Y";"-K");
          		        //     CMYK TIF ( )

 Method	: integer;   	        //   8- 
          		        //  CMYK  1-:
          		        //  0 -   ( 8- );
          		        //  1 -     Shape
          		        //      DPI/LPI
 Shape	: integer;   	        //   ()  
          		        // ( Method = 0 ):
          		        //  0 -    
          		        //     ( Method = 0 )
 AngleC 	: double;  	// 15 
 AngleM 	: double;  	// 75 
 AngleY 	: double;  	//  0 
 AngleK 	: double;  	// 45 

 _Reserve	: array[0..95] of char;  	//  (  512 )

 Cross	        : byte;   	//     ( ColorModel > 0)
          		// (1 - ; 0 - ); (  )
 Negative	: byte;     	//     ( BitCount = 1)
          		// (1 - ; 0 - ); (  )
 Mirror 	: byte;      	//     ( BitCount = 1)
          		// (1 - ; 0 - ); (  )
 Turn	        : byte;       	//     90  ( BitCount = 1)
          		// (1 - ; 0 - ); (  )

 FileName       : array[0..259] of char;  	//     (BMP; PCX; TIF)
           	//   1.BMP ( BitCount = 1) 
           	//  : 1-.BMP; 1-M.BMP; 1-Y.BMP; 1-K.BMP

           	//   1.PCX ( BitCount = 1) 
           	//  : 1-.PCX; 1-M.PCX; 1-Y.PCX; 1-K.PCX
           	//      
end;
TSAVEASPICTRPARM = TSAVEASPICTRPARM_FOR_PRINT;

// ------------------------------------------
 TMAPREGISTER   = packed record
   Length    : cardinal;      //   
   Name      : TSmallString;    //  
   Scale,                     //  
   ProjectionFlag,            //   
   EllipsoideKind,            //  
   HeightSystem,              //  
   MaterialProjection,        //  . 
   CoordinateSystem,          //  
   PlaneUnit,                 //    
   HeightUnit,                //    
   FrameKind,                 //  
   MapType,                   //   
   DeviceCapability,          //   
   DataProjection,            //    
   OrderViewSheetFlag,        //   
   FlagRealPlace,             //   
   ZoneNumber   : cardinal;   //    
                                             //  -     
   FirstMainParallel,         //   
   SecondMainParallel,        //   
   AxisMeridian,              //  
   MainPointParallel: double; //   
  end;

  TMAPREGISTEREX  = packed record
   Length    : integer;      //     //06/11/2010
   Name      : array[0..31] of Char;    //  
   Scale,                     //  
   ProjectionFlag,            //   
   EllipsoideKind,            //  
   HeightSystem,              //  
   MaterialProjection,        //  . 
   CoordinateSystem,          //  
   PlaneUnit,                 //    
   HeightUnit,                //    
   FrameKind,                 //  
   MapType,                   //   
   DeviceCapability,          //   
                                      //   20 000
                                     //    :  // 26/12/06
                                     // -1 -  
                                     // -2 -    
                                     // -3 -    
   DataProjection,            //    
   OrderViewSheetFlag,        //   
   FlagRealPlace,             //   
   ZoneNumber   : integer;    //       //06/11/2010
                              //  -     
   FirstMainParallel,         //   
   SecondMainParallel,        //   
   AxisMeridian,              //  
   MainPointParallel,         //   
   PoleLatitude,              //   
   PoleLongitude,             //   
   FalseEasting,              //     Y 06/11/2010
   FalseNorthing,             //     X
   ScaleFactor,               //  
   TurnAngle:  double;        //       ()
   Reserv2 : array[0..3] of double; //  = 0
  end;
   PMAPREGISTEREX = ^TMAPREGISTEREX; // 07/10/2009




 TLISTREGISTER = packed record
    Length       : cardinal;      //   
    Nomenclature : TSmallString;      //  
    ListName     : TSmallString;      //  
    FileName     : array[0..259] of char;     //       
                                              //     
                                              //   HDR, DAT, SEM, DRW
//     
    XSouthWest,                    // X -
    YSouthWest,                    // Y -
    XNorthWest,                    // X -
    YNorthWest,                    // Y -
    XNorthEast,                    // X -
    YNorthEast,                    // Y -
    XSouthEast,                    // X -
    YSouthEast,                    // Y -
//     
    BSouthWestCoordinate,          // B -
    LSouthWestCoordinate,          // L -
    BNorthWestCoordinate,          // B -
    LNorthWestCoordinate,          // L -
    BNorthEastCoordinate,          // B -
    LNorthEastCoordinate,          // L -
    BSouthEastCoordinate,          // B -
    LSouthEastCoordinate : double; // L -
    MaterialKind,                  //   
    MaterialType,                  //  
    ReliefHeight : cardinal;       //   
    sDate  : array[0..10] of char;  //   ""
    MagneticAngle,                 //  
    YearMagneticAngle,             //   
    MeridianAngle :  double;       //   
    DateAngle   : array[0..10] of char; //   ""
    Reserv2     :array[0..2]of cardinal;      // = 0
    BorderSW    : TDOUBLEPOINT;        //   ( 0 !)
  end;




  TCREATESITEUN = packed record   // 26/06/2007
   Length  : integer;            //    CREATESITE
   MapName : array [0..127] of WideChar; //     ANSI (UNICODE -   "Un") 13/08/2007
   MapType : integer;            //   
   MaterialProjection : integer; //  . 
   EllipsoideKind : integer;     //   (1 - , 9 - WGS84,...) //22/02/2009
   Scale : integer;              //   
   Reserve : integer;            //  (  0)
   FirstMainParallel : double;   //   
   SecondMainParallel : double;  //   
   AxisMeridian : double;         //  
   MainPointParallel : double;    //   
   PoleLatitude : double;         //   
   PoleLongitude : double;        //   
  end;

  //----------------------------------------------------------------------------
  TMTRCOLORDESCEX = packed record  //    
    MinHeight  : double;           //   
    MaxHeight  : double;           //   
    Color      : TColorRef;        // ,  
  end;

  TXIMAGEDESC    = packed record    //    XImage
                                    // (   XWindow)    // 25/09/00
    Point       : Pointer;          //    
    Width       : integer;          //    
    Height      : integer;          //  
    Depth       : integer;          //     (8,15,16,24,32)
    CellSize    : integer;          //  ()  
    RowSize     : integer;          //    
  end;

 //    
  TRSCCREATE   = packed record
    rscName  : TSmallString;          //   (  19 )
    rscType  : TSmallString;          //   (  25 )
    rscCode  : array[0..7] of char;   //   (  4 )
    Scale    : Cardinal;              //  
    Language : Cardinal;              //  (MAPAPILANGUAGE)
  end;

  TRSCSEGMENT  = packed record
    Order    : Cardinal;              //     
    rscSegName  :TSmallString;        //  (  30 )
  end;

  //   ,   
 TSERIALIMIT = packed record
  Code     : integer;                   //  
  Count    : integer;                   //   (>=2)
  Value    : array [0..255] of double;  //  
 end;

 //    
 TSERIATYPE  = packed record
    Excode      : cardinal;     //   ' 
    Local       ,               //    ' 
    Count       ,               //   
    FirstCode   ,               //   
    FirstCount  ,               //    1 
    SecondCode  ,               //   
    SecondCount :  integer;     //    2 
 end;

 //    
 TSERIAPLACE = packed record
   FirstCode   ,                //  
   FirstNumber ,                //   ( 1)
   SecondCode  ,                //   ,    ,  
   SecondNumber : integer;      //   ( 1)
 end;

 TElemTree = packed record
   Ident : integer;           //   ( 0,  )
   Depth : integer;           //    
   LayerNumber : integer;     //  
   ParentNumber : integer;    //      
   PictureIndex : integer;    //    
   Code : array [0..27] of char;   //   ( )
                             //       
  end;

 TDRAWSIZE = Types.TSize;  //  TSize

 TDRAWLINE = packed record     //  
  First  : TPoint;
  Second : TPoint;
 end;

 TDRAWBOX = packed record     //  
  Point1 : TDrawPoint;
  Point2 : TDrawPoint;
  point3 : TDrawPoint;
  Point4 : TDrawPoint;
 end;

 TBOX = packed record     // /26/03/12
  LT : integer;
  UP : integer;
  RT : integer;
  DN : integer;
 end;

  HVIEW = integer;

  //------------------------------------
  TPaletteElement = packed record
   case byte of
    0: (R,G,B,Alpha : byte);
    1: (Value : Cardinal);
    2: (Color : TColor);
  end;

  TPALETTE256  = packed record
   palVersion    : word;
   palNumEntries : word;
   palPalEntry   : array[0..255] of TPaletteElement;
  end;

  TIMAGEFRAME    = packed record
   LeftTop      : TDoublePoint;      //     
   RightTop     : TDoublePoint;      //     
   RightBottom  : TDoublePoint;      //     
   LeftBottom   : TDoublePoint;      //     
  end;

  //        (" '")
  TRSCRELATION  = packed record                         // 01/11/01
    ObjectCode   : Cardinal;            //    
    SemanticCode : Cardinal;            //   
    Prefix       : array[0..6] of byte; //   ()  
    Decimal      : byte;                //    
  end;


  //     '
  TAPPLYSEMANTIC  = packed record //  ', 
    Possible : integer;   //  
    Must     : integer;    //  
    Image    : integer;    //     
  end;

  TRscFont  = packed record             //  
   Font     : TSmallString;             // 
   Name     : TSmallString;            //  
   CharSet  : integer;                  //  
  end;

  TSignDegree  = packed record    //    
   Degree  : integer;    // 
   Minute  : integer;    // 
   Second  : double;     // 
   Sign    : integer;    //   (+1  -1)
  end;

  PXYHDouble = ^TXYHDouble;

  TXYHDouble  = packed record
   X,Y,H : double;
  end;
  TXYHPoint =  TXYHDouble;

 //    
 TBUILDZONEVISIBILITY  = packed record                  // 18/05/05
   PointCenter       : TDoublePoint;      //  
   RadiusMeter       : double;  //  (   )
   Azimuth           : double;  //  ( )
   Angle             : double;  //   ( )
   DeltaHight        : double;  //   ( )
   DeltaObservation  : double;  //    ( )
   VisionRst         : integer; //   
                                // 0-  , 1-   
   StyleRst          : integer; //   
                                // 0-, 1-
                                // 2-
   ColorRst          : integer; //  
   Inversion         : integer; //  
 end;

 TMTRPROJECTIONDATA  = packed record //     
                                     //   (  )
   StructSize     : integer;    //    : 128 
                                //  sizeof (MTRPROJECTIONDATA)
   pFree          : integer;    //   
   MapType        : integer;    //   (  
                                //    MAPTYPE,  MAPCREAT.H)
   ProjectionType : integer;    //   (  
                                //    MAPPROJECTION,  MAPCREAT.H)
                                // long  MaterialProjection; //  . 
                                //  
   FirstMainParallel,         //   
   SecondMainParallel,        //   
   AxisMeridian,              //  
   MainPointParallel,         //   
   PoleLatitude,              //           // 27/06/05
   PoleLongitude  : double;   //          // 27/06/05

   EllipsoideKind,            //          // 01/07/05
   HeightSystem,              //           // 01/07/05
   CoordinateSystem,          //       // 01/07/05
   ZoneNumber      : integer; //      // 28/11/07
   Reserve : array[0..47] of byte;        //   
 end;

 TMTR3DVIEWEX   = packed record //  3D-  (MTW  MTL)
    AreaCenterX,                //    X,Y
    AreaCenterY,                //   (   )
    CutX,                       //   / X,Y,Z
    CutY,                       //   (   )      -  MTL
    CutZ,
    CutH           : double;    //    ( )
    ShowScale,                  //    
    ModelHeight,                //     (2 - MTL3D_MAXMODEL)
    GridStep,                   //     (2 - 100)
    CutShape       : integer;   //   (. CUTSHAPE)   -  MTL
    ViewAngle      : integer;   //  / ( )
    RotationAngle  : integer;   //     AreaCenter
                                //   ( )
    Style,                      // C (0 - , 1 - )
    ShowGrid,                   //   (0 - , 1 - )
    Shadow,                     //   (0 - , 1 - )
    ScaleType,                  //   (. SCALETYPE)      -  MTL
    CoverMatrix,                //      (0 - , 1 - )
    CoverMap,                   //             (0 - , 1 - )
    CoverRaster,                //            (0 - , 1 - )
    AccordScale,                //    (0 - , 1 - )
    CoverMtq,                   //   (0 - , 1 - )  // 06/10/04
    IsUpdate       : byte;      //   (0 - , 1 - )    // 21/10/05
    Reserve        : array[0..25] of byte;
    CursorX        : double;    //   X,Y
    CursorY        : double;    //   (   )
    Width          : integer;   //  
    Height         : integer;    //  
    Name           : TFullString; //    
                                   //   (0 -   )    -  MTL
end;

 TBUILDSURFACE   = packed record     // 29/05/07
  StructSize : Cardinal;        //    : sizeof (BUILDSURFACE) = 320 
  FileMtw    : integer;         //     :
                                //   0 -     (*.mtq)
                                //   1 -     (*.mtw)
  BeginX,                       //   
  BeginY,                       // (- )   
  Width,                        //    
  Height,                       //    
  MinValue,                     //      ,
  MaxValue,                     //  MinValue >= MaxValue   
                                //   
  ElemSizeMeters: double;       //    
                                //     ( )
  UserType : integer;           //  ,    
                                //  (,  )
  pFree    : integer;           //   
  UserName : TSmallString;      //    (  )

  Border : HObj;  //    ,  
                  //    (  ,   )
                  //      ,  
                  //  BeginX, BeginY, Width, Height  ,   

  Handle : HWnd;  //   ,  
                  //  0x0581     ( WPARAM),
                  //      ,  
                  //    0x0581.
                  //  Handle   -   .

  Palette : PColorRef;     //     (*.mtq),
                           //    -    
  PaletteCount : integer;  // K    ( 1  256)

  Method : integer;       //    :
                          //  8 -     
                          //      (    PointArray )
                          //  9 -     
                          //         
                          //      (      )

  PointArray : PXYHDouble;  //      ( Method = 8)
  PointCount,    //     PointArray ( Method = 8)=
  SemanticCode,  //     ( Method = 9)
  LocalSurfacePointCount,  // K     
                                   //    ( Method = 9)
  LocalSurfaceRebuildPointCount : integer; // K    
                                           //    ,
                                           //    
                                           //  ( Method = 9)
  MaxMetricCutLength : double;  //      
                                //    ( Method = 9)

  Use3DMetric  : integer;    //        :  // 06/11/07
                             //  0 -      
                             //  1 -     

  Name : array[0..163] of byte;  //   
 end;

 //      GeoTIFF-
 TGEOTIFFINFORMATION  = packed record   // 20/03/03
   StructSize,                  //  
   TypeCS,                      //   
   Spheroid,                    // 
   Datum,                       //  
   PrimeMeridian,               //  
   Projection,                  // 
   Zone,                        //  
   Units            : Cardinal; //    (,  ...)
   FrameImage       : TDFrame;  //    
   UnitsInElement_X,            //        X
   UnitsInElement_Y,            //        Y
   UnitsInElement_Z : double;   //        Z
   Information      : TFullString;//   ,    ..
   PrecisionInch    : double;    //    (\) // 01/11/05
   PrecisionMet     : double;   //    (\) // 01/11/05
   UnitsAngular     : Cardinal; //    (,  ...)  // 28/03/06
   Reserv           : array[0..43] of char;
 end;


  TMAPLISTPARM       = packed record  //    " "
   Handle        : HWnd;         //   
   PageNumber    : integer;      //        " "
                                 //  0 -   " "
                                 //  1 -   " "
                                 //  2 -   " "
   SaveMtrPath,                  // 
   SaveRstPath,                  // 
   SaveSitPath,                  // 
   SaveTinPath   : TPathString;  // 31/03/05
   RstPageNumber,                //    " " 
                                 //  ()   - 0(1);
   MtrPageNumber,                //    " " 
                                 //  ()   - 0(1);
   SitPageNumber,                //    " " 
                                 //  ()   - 0(1);
   TinPageNumber,                // 31/03/05
   RstNumber,                    //       " "
   MtrNumber,                    //       " "
   SitNumber,                    //       " "
   TinNumber     : integer;      // 31/03/05
   CentrePosition: TDoublePoint; //       
  end;


  TPALETTECNTPARM    = packed record  //    " "
   Handle                 : HWnd;        //   
   ColorOfSelectObject,                  //   
   ColorOfSelectedObjects,               //   
   ColorOfSetObjects      : TColorRef;   //     //04/05/00
   ThickOfSelectObject    : integer;     //    
  end;

  TLINEOFLIST   = packed record       // 27/02/02
   OldNumber : integer;
   Name      : TPathString;
  end;

 TCHOICEOBJECTPARM  = packed record
   Select    : hSelect;         // 
   MapSelect : integer;         //      
                                //  = 0  -     
                                //  = 1  -     ( 
                                //            )
   MapEditSelect: integer;      //       (  )
                                //  = 0  -     
                                //  = 1  -   ,  
  end;


  //-----------------------------------------------------------------
//    
//-----------------------------------------------------------------

 TMAPPRINTPARM      = packed record
   Length : Cardinal;   //   MAPPRINTPARM
   Handle: HWND;        //   
                                                           // 0x008 (8)
   Scale,                //   ()
   ScaleSave : integer;  //   (  FitToPage = 1)
                                                           // 0x010 (16)
   RectMetr : TRect;     //     ( )
                                                           // 0x020 (32)
   ShiftLTmm,            //  ( )
   ShiftUPmm,            //
                                                           // 0x028 (40)
   FieldLTmm,            //   ( )
   FieldUPmm,            //
   FieldRTmm,            //
   FieldDNmm,            //
                                                           // 0x038 (56)
   Intensity,            //    (0-100)
   Copies : integer;     //  
                                                           // 0x040 (64)
   Regime,               //    (. MAPPRINT_REGIME)
   Preview,              //    (. MAPPRINT_PREVIEW)
   TypePrint,            //   (. MAPPRINT_TYPE)
   TypeOutput,           //   (. MAPPRINT_OUTPUT)                                                          // 0x044 (68)
   Orientation,          //  (. MAPPRINT_ORIENT)
   FileFlag,             //    (1 - , 0 - )
   Border,               //    (1 - , 0 - )
   FitToPage,            //    
                         //   (. MAPPRINT_FITTING)
   Black,                //  -  (1 - , 0 - )
   Calibration,          //    
                         //   (1 - , 0 - )
   Mirror   : byte;      //    (1 - , 0 - )

   Reserve  : byte;       //  (  )
                                                           // 0x04C (76)
   FileName : TPathString;//   
                                                           // 0x150 (336)
  end;


 TMAPPRINTPARMEX    = packed record
   Length : Cardinal;   //   MAPPRINTPARM
   Handle: HWND;        //   
                                                           // 0x008 (8)
   Scale,                //   ()
   ScaleSave : integer;  //   (  FitToPage = 1)
                                                           // 0x010 (16)
   RectMetr : TRect;     //     ( )
                                                           // 0x020 (32)
   ShiftLTmm,            //  ( )
   ShiftUPmm,            //
                                                           // 0x028 (40)
   FieldLTmm,            //   ( )
   FieldUPmm,            //
   FieldRTmm,            //
   FieldDNmm,            //
                                                           // 0x038 (56)
   Intensity,            //    (0-100)
   Copies : integer;     //  
                                                           // 0x040 (64)
   Regime,               //    (. MAPPRINT_REGIME)
   Preview,              //    (. MAPPRINT_PREVIEW)
   TypePrint,            //   (. MAPPRINT_TYPE)
   TypeOutput,           //   (. MAPPRINT_OUTPUT)                                                          // 0x044 (68)
   Orientation,          //  (. MAPPRINT_ORIENT)
   FileFlag,             //    (1 - , 0 - )
   Border,               //    (1 - , 0 - )
   FitToPage,            //    
                         //   (. MAPPRINT_FITTING)
   Black,                //  -  (1 - , 0 - )
   Calibration,          //    
                         //   (1 - , 0 - )
   Mirror,               //    (1 - , 0 - )
   CutLine : byte;       //     (1 - , 0 - )
                         //   ( OverlapLT, OverlapUP,
                         //    OverlapRT  OverlapDN > 0) // 0x04C (76)
   FileName : TPathString;//   
                                                           // 0x150 (336)
   OverlapLTmm,          //    
   OverlapUPmm,          //        ( )
   OverlapRTmm,          //
   OverlapDNmm : integer;//
                                                           // 0x160 (352)
   PageWidth,            //      
   PageHeight,           //   ( )
                                                           // 0x170 (368)
   Angle  : double;       //    ( )
                                                           // 0x178 (376)
   PlaneFrame : TDFRAME;  //     
                          // (  -    ).
                          //  X1,Y1 - 1   
                          //  X2,Y2 - 3   
                          //  TurnFrame = 1,  1  3  
                          //  ,   
                                                           // 0x198 (408)
   SiteDecor : HSITE;     //   (  )
                                                           // 0x19C (412)
   FrameKey : integer;    //   ,   
                          //    PlaneFrame
                          // (  0   ,
                          //    )
                                                           // 0x1A0 (416)
   FrameList : TSmallString;   //   ()  FrameKey
                                                           // 0x1C0 (448)
   PaperWidth,            //   ( )
   PaperHeight : integer; //
                                                           // 0x1C8 (456)
   ReserveEx : array [0..49] of char;   //  (  )

   FileCount,             //    (  PostScript = 1)
                          //   (1 -      C,M,Y,K  R,G,B
                          //    4 -       
                          //          C,M,Y,K)
                                                             // 0x1FB (507)
   ColorModel,            //     PostScript
                          //   (0 - RGB, 1 - CMYK)
   PostScript,            //  PostScript-
   Restore,               //    
                          //    INI-  (1 - , 0 - )
   TurnFrame,             //     (1 - , 0 - )
   Decoration : byte;    //    (  )
 end;


 TRESTOREMODE       = packed record
   Note          : integer;  //   /  
   VisualSeek    : integer;  //       .
   MapSeek       : integer;  //    .
   RestoreSelect : integer;  //    .
  end;

//         

// Note                    
// VisualSeek
//                  "-1" -   ;
//                  "0"  -      ;
//                  "1"  -      .
// MapSeek
//                  "-1" -   ;
//                  "-2" -     ;
//                  "0...n" -       .
// RestoreSelect
//                  "-1" -    ;
//                  "0"  -     .


//         .

 TAREASEEKPARM     = packed record
    Size,          //  .
    RestoreSelect, //      .
    ToSelectArea,  //    
    VisualSeek,    //       .
    MapSeek,       //    .
    AreaType,      //   : / .
    InsideFlag,    //   .
    FilterFlag,    //    .
    AreaAction,    //    .
    InversionFlag : integer; //           26/02/02
    Distance : double;      //   ( ).
 end;

 TARRAYNAME = packed record
     Code  : integer;         //    
     Title : integer;         //   
     Count : integer;         //   
     //       
     Names : array[0..15] of TFullString;
 end;

  TNAMESARRAY = packed record
     Size  : integer;         //    
     Count : integer;         //   
     Lists : TPathString;     // 
 end;

type
 TINFOLIST  = packed record
  Nomenclature  : TSmallString;  // 
  Scale         : integer;       // 
  CountObject   : integer;       //  
  MapType       : integer;       //  
 end;



 TINFOSXF  = packed record
   SheetName    : TSmallString;    // 
   Nomenclature : TSmallString;    // 
   RealCoord    : integer;         //   
   Scale        : integer;         //  
   RecordCount  : integer;         // - 
   MapType      : integer;         //  
 end;

 TINFODIR  = packed record
  SheetName     : TSmallString;    // 
  NameRsc       : TPathString;     // 
  CountList     : integer;         //  
 end;

 const
   AM_HEAD      = 1;        //   
   AM_METRIC    = 2;        //   '
   AM_SEMANTIC  = 4;        //  
   AM_DRAW      = 8;        //   


 type
 TACTIONRECORD  = packed record//   
                        // ( AT_OPEN -   16 )
  Key     : integer;    //     
  Number  : integer;    //     
  Back    : integer;    //      ()
  OpType  : integer;    //  
  Mask    : byte;       //    
  List    : shortint;   //  
 end;

 TACTIONHEAD  = packed record   //   
  Ident    : word;      // 0x7FFF
  Task     : shortint;  //  , 
  Count    : word;      //   (Length = 16+Count*16)
  trType   : word;      //   ( )
  trDate   : integer;   //   
  trTime   : integer;   //   
 end;
 
//---------------------------------------------------------------------------
//    ini-    "3D-"
//---------------------------------------------------------------------------
 const
  IniFileSection  = 'MAP3D';

 type
  HTASK3D = Cardinal;    //    
                              // (, , )

//---------------------------------------------------------------------------
//       3D-
//---------------------------------------------------------------------------
 TCREATETASK3D  = packed record

  SelectFrame : TMapDFrame;   //     
                              //   (   )
  Area        : integer;      //   :
                              //   0 -  
                              //   1 -    (SelectFrame)
                              //   2 -    
  MoveAdjust  : integer;      //   -   
                              //   0 -  
                              //   1 -  
                              //   2 -  
                              //   3 -   
                              //       
                              //   wParam (notification code)
                              //   WM_COMMAND,    3D-
                              //  ,    
                              //   3D-   
                              // ( ,    )
  CmStop3d,                   //     
  CmMove3d,                   //     
                              // 3D-    
                              // 
  CmSelectFrame3d,            //     
                              //       
                              // 3D-
  CmSelectObject3d,           //       
                              //   
  CmScale3d : integer;        //   
                              //  
  Reserve :array[0..251] of char;
 end;

 type
//------------------------------------------------------------------
//    TIN-
//------------------------------------------------------------------
  TTINBUILD  = packed record    //   320 
    Length,             //   : sizeof(TINBUILD)
    UserLabel,          //   -
                        //  , 
                        //   
    ModelType,          //  
                        //  : 1 -   
                        //            2 -  
    Method : integer;   //   
                        //  : 1 -  
                        //                 
    FrameMeters : TDFrame;    //     ()

    ModelRegister : TMAPREGISTEREX ;    //   
                      // a MAPREGISTEREX a  MAPCREAT.H
                      //   TIN- 
                      //    :
                      //  Name -   ,
                      //  Scale -  ,
                      //  EllipsoideKind -   (
                      //       ELLIPSOIDKIND,  MAPCREAT.H),
                      //  HeightSystem -   (
                      //       HEIGHTSYSTEM,  MAPCREAT.H),
                      //  MaterialProjection -   
                      //    (    MAPPROJECTION,  MAPCREAT.H),
                      //  CoordinateSystem -   (
                      //       COORDINATESYSTEM,  MAPCREAT.H),
                      //  MapType -    (
                      //       MAPTYPE,  MAPCREAT.H),
                      //  FirstMainParallel -   ,
                      //  SecondMainParallel -   ,
                      //  AxisMeridian -  ,
                      //  MainPointParallel -   .

    Border : HObj;    //    ,
                      //     
                      // TIN- (    
                      // ,    FrameMeters
                      //  ,    )

    Reserve : array[0..59] of char;    //   
  end;

//------------------------------------------------------------------
//    TIN-
//------------------------------------------------------------------
  TTINDESCRIBE  = packed record      //   1024 
   Name : array [0..259] of char;     //   
   Length,              //  
   UserLabel,           //  
   ModelType,           //  
   Method,              //   
   VertexCount,         //  
   TriangleCount,       //  
   View    : integer;   //  

   FrameMeters : TDFrame;    //     ()

   MinHeightValue : double;    //     ()
   MaxHeightValue  : double;     //     ()

   ModelRegister : TMAPREGISTEREX ;  //   
                      // a MAPREGISTEREX a  MAPCREAT.H
                      //  TIN-  
                      //   :
                      //  Name -   ,
                      //  Scale -  ,
                      //  EllipsoideKind -  ,
                      //  HeightSystem -  ,
                      //  MaterialProjection -   ,
                      //  CoordinateSystem -  ,
                      //  MapType -   ,
                      //  FirstMainParallel -   ,
                      //  SecondMainParallel -   ,
                      //  AxisMeridian -  ,
                      //  MainPointParallel -   .

   ModelSquare : double;       //   (.)

   Reserve : array [0..471] of char;      // 

end;

//------------------------------------------------------------------
//    TIN-
//------------------------------------------------------------------
 TTINVERTEXFLAG = packed record      //   8 
   Cancel,              //  
   PolygonBorder,       //   
                        //   
   StructLine ,         //    
   FaultLine,           //    
   FillingSquare : byte;//     
   Reserve : array [0..2] of char;
 end;

//------------------------------------------------------------------
//     TIN-
//------------------------------------------------------------------
 TTINVERTEX = packed record     //   40 
   X,                           //    
   Y,                           //     ()
   H :double;
                                //  ,     
   UpperVertexNumber,           //    
   UnderVertexNumber : integer; //    

   Flag : TTINVERTEXFLAG;       //  
end;

//------------------------------------------------------------------
//    TIN-
//------------------------------------------------------------------
 TTINTRIANGLEFLAG = packed record     //   16 
   Cancel    : byte;     //  

   Location  : byte;     //     
                         // (0 -   ,
                         //  1 -   )

   FillingSquare : byte; //    
                         //  

   AB,                   //   "AB"
   BC,                   //   "BC"
   CA : byte;            //   "CA"
                         // (0 -     
                         //       ,
                         //  1 -     
                         //        ,
                         //  2 -     
                         //        ,
                         //  3 -     
                         //       ,
                         //  4 -     
                         //        )
  Reserve : array [0..9] of char;

end;
  
//------------------------------------------------------------------
//     TIN-
//------------------------------------------------------------------
 TTINTRIANGLE = packed record    //   40 
  A,            //   "A"   
  B,            //   "B"   
  C,            //   "C"   

  AB,           //      "AB"
                //   
  BC,           //      "BC"
                //   
  CA : integer; //      "CA"
                //   
                // (   ,   -1)
  Flag : TTINTRIANGLEFLAG ;  //  
end;


 //  GISMRTEX api
 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++     ++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

 //    
 //  


  TPRIORMTRPARM = packed record
   Length : integer;               //    :
                                   //  sizeof (PRIORMTRPARM) = 64
   Free   : integer;               //   
   AbsHeightDifference : double;   //    - 
                                   //    
                                   //     ()
   Reserve : array [0..5] of double;          //   
  end;



 TALSITEM = packed record                //     
  Ident         : cardinal;             //  
  Path          : array[0..259]of char; //     
  Name          : array[0..31]of char;  //   (  )
  Scale         : integer;              //   (  )
  Minimum       : integer;              //      (, 100 000)
  Maximum       : integer;              //      (, 500 000)
  Priority      : integer;              //     
 end;

 TALSITEMEX = packed record   //                                                                        // 21/11/06
  Ident         : cardinal;             //           // 21/11/06
  Scale         : integer;              //   (  )
  Minimum       : integer;              //      (, 100 000)
  Maximum       : integer;              //      (, 500 000)
  Priority      : integer;              //     
  Reserve       : integer;              //  = 0
 end;


const
  WM_RSTROTATE     =  $0500;       //  
  RSTTRANS_DIAL    =  $0501;       //   - 
  STTRANS_NEWPARM  =  $0502;       //   .
  RSTTRANS_END     =  $0503;       //  

//   ,    ( )

  SEMALSPATH   = 7701;  //   
  SEMALSNAME   = 7702;  //   
  SEMALSSCALE  = 7703;  //   
  SEMALSMIN    = 7704;  //   
  SEMALSMAX    = 7705;  //   
  SEMALSMODE   = 7706;  //   
  SEMALSPRIOR  = 7707;  //  
  ALS_UP       =  1;  //    
  ALS_DOWN     =  2;  //    
  ALS_ANY      =  0;  //   
  ALS_BACK     =  4;  //   
 
 //    " "

  SAP_SAVEONLY    = -2;  //     
                        //
  SAP_INITPARM    = -1; //    
                        //  ( ""  "" )
  SAP_SAVEALL     =  0;  //     
                        //       
  SAP_SAVE        =  1;  //     
                        //   (RectMetr)
  SAP_SELECTFRAME =  2; //     
                        //
  SAP_CHANGEFRAME =  3; //    
                        //  
  SAP_MOVEFRAME   =  4; //          // 23/08/01
  SAP_SELECTBYOBJECT = 5;//      
                        //   


  // ,   Regime    :
  // "" - SAP_SAVE,
  // ""   - SAP_SELECTFRAME,
  // ""  - SAP_CHANGEFRAME,
  // "" - SAP_MOVEFRAME,
  // " "- SAP_SELECTBYOBJECT
  //  ,     
  //        Regime.

  SAP_NORMALRASTER= 1;  // ()
  SAP_TRANSPARENTRASTER= 2;  // ()

  SAP_NORMAL      = 3;  // 
  SAP_TRANSPARENT = 4;  // 
  SAP_CONTOUR     = 5;  // 

 
//    
//     
const
//     
  IDC_PERCENT_DELONE      = $3000;
  TR_ONLY          = 0;
  TR_THICKEN       = 1;
  TR_FACTORIZATION = 2;

//    
  VERTEXCOUNT     = 50000;  // 29/12/05

//    
  TRIANGLECOUNT  = 150000;  // 29/12/05

//      (56 )
 type


 TTRIANGLE  = packed record
  A,B,C                 : integer;  //   
  EdgeAB,EdgeBC,EdgeCA  : integer;  //   
  NearAB,NearBC,NearCA  : integer;  //   
  ParentAB,             //     (1-, 0-)
  ParentBC,
  ParentCA              : integer;
  Cancel                : integer;   //  
  Reserve               : integer;
 end;
//      (32 a)

 TEDGE  = packed record
  A,B        : integer;    //   
  LTri,                    //   
  RTri       : integer;    //   
  Live       : integer;    //  - ""  (    )
  Cancel     : integer;    //  
  Flag       : integer;    //  :
                    //  0 -     
                    //       ,
                    //  1 -     
                    //        ,
                    //  2 -     
                    //        ,
                    //  3 -     
                    //       ,
                    //  4 -     
                    //        .
  Reserve : integer;
 end;

//      (32 a)

 TVertex = packed record
  X,Y,H    : double;
  Cancel   : integer;   //  
  Flag     : integer;   //  : 0 -   ( )
                        //        1 -    
                        //        2 -     
 end;

    {
//   
// Hdc   -   Windows - "HDC",  UNIX - "XCONTEXT*", .mapapi.h
// Size  -    ,    0,0
// View  -     (/)
// HView -      (   !)
// Scale -       
//   ( 1,      ,
//          1,
//    ,    ).
//   ,      1:200000
//     1:500000,    0.4 .
//       .
//       -     1.
// (    (!)  ""
//     : Real = 2 * Scale - 1;
//    ""    
//    (Scale < 1.0),
//   Scale    ;
//  ScaleMethod - c .

 TIMGCONTEXT = packed record
  Length : integer;     //     (64 )
  DC     : HDC;         //    (   UNIX = 0)

  ViewType   : integer; //   VT_SCREEN, VT_PRINT (maptype.h)
  View       : HVIEW;   //    ( )

  Size       : TSize;   //   

  Scale      : double;  //    
                        //   (  
                        //      1)
  ScaleMethod : integer;    //   (0 - ,
                        // 1 - ,  "")

  PixelX : double;      //      
                        //  
  PixelY : double;      //      
                        //  

  SinAngle,             // Sin          // 19/09/01
  CosAngle,             // Cos   
  Angle      : double;  //    (  )
  Reserv : array[0..1] of char;     //  = 0
 end;  }

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// +++++++++++++       +++++++++++++++
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TPUTTOMAPINFO = packed record
  Incode   : integer;   //   
  MapNumber: integer;   //  
  Regime   : integer;   //   
end;

// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//       , 
//              
// +++++++++++++++++++++++++++++++++++++++++++++++++++++++++
TCOMMITOBJECTPARM = packed record   // 11/04/11
  MinCutLength : double;          //     
                                // (   )

  //        
  //          :
  // mapCommitWithPlace(), mapCommitWithPlaceAsNew().
  //   ,    MinLineLength,
  //    .

  MinCutLengthOnBorder : double;  //     ,
                                //    (   )

  //      
  //    ,   
  //     :
  // mapCommitWithPlace(), mapCommitWithPlaceAsNew().
  //      :
  // 1) ,     ,
  //          MinCutLengthOnBorder;
  // 2) ,     ,
  //         MinCutLengthOnBorder.
  _Reserve : array [0..47] of char;             // 
end;

{$include Mapgdi.inc}

implementation

end.




